
Imports System.Data
Imports System.Data.SqlClient
Imports System.Xml

Namespace Jeff
    Public Class Form1
        Inherits System.Windows.Forms.Form

        Const SQL_CONNECTION = "Data Source=localhost;" & _
                        "Initial Catalog=Northwind;User ID=sa;"

        Const SQL_SUPPLIERS = "SELECT * FROM Suppliers"

        Const SQL_PRODUCTS = "SELECT * FROM Products"

        ' Note: @ must be replaced by a country name
        Const SQL_SUPPLIERS_BY_COUNTRY = _
                "SELECT Suppliers.SupplierID, Suppliers.CompanyName, " & _
                "Suppliers.ContactName, Suppliers.ContactTitle, Suppliers.Phone " & _
                "FROM Suppliers WHERE Suppliers.Country = '@'"

        ' Note: @ must be replaced by a country name
        Const SQL_SUPPLIERS_AND_PRODUCTS_BY_COUNTRY = _
                    "SELECT Suppliers.SupplierID, Suppliers.CompanyName, " & _
                    "Products.ProductName, Products.UnitPrice, Products.UnitsInStock " & _
                    "FROM Suppliers INNER JOIN Products ON Suppliers.SupplierID = Products.SupplierID " & _
                    "WHERE Suppliers.Country = '@'"

        Const SQL_COUNTRIES = "SELECT DISTINCT Suppliers.Country FROM Suppliers"

#Region " Windows Form Designer generated code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Windows Form Designer.
            InitializeComponent()

            'Add any initialization after the InitializeComponent() call

        End Sub

        'Form overrides dispose to clean up the component list.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub
        Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid

        'Required by the Windows Form Designer
        Private components As System.ComponentModel.Container

        'NOTE: The following procedure is required by the Windows Form Designer
        'It can be modified using the Windows Form Designer.  
        'Do not modify it using the code editor.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
            Me.btnProducts = New System.Windows.Forms.Button()
            Me.btnListProductByCountry = New System.Windows.Forms.Button()
            Me.cboCountries = New System.Windows.Forms.ComboBox()
            Me.DataGrid1 = New System.Windows.Forms.DataGrid()
            Me.btnDataView = New System.Windows.Forms.Button()
            Me.btnQuery = New System.Windows.Forms.Button()
            Me.btnQuery2 = New System.Windows.Forms.Button()
            Me.btnUpdate = New System.Windows.Forms.Button()
            Me.btnSuppliers = New System.Windows.Forms.Button()
            Me.btnXML = New System.Windows.Forms.Button()
            Me.SqlDataAdapter1 = New System.Data.SqlClient.SqlDataAdapter()
            Me.SqlSelectCommand1 = New System.Data.SqlClient.SqlCommand()
            Me.SqlInsertCommand1 = New System.Data.SqlClient.SqlCommand()
            Me.SqlUpdateCommand1 = New System.Data.SqlClient.SqlCommand()
            Me.SqlDeleteCommand1 = New System.Data.SqlClient.SqlCommand()
            Me.SqlConnection1 = New System.Data.SqlClient.SqlConnection()
            Me.DsSuppliers1 = New TestADONetChap2.dsSuppliers()
            CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.DataGrid1.SuspendLayout()
            CType(Me.DsSuppliers1, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.DsSuppliers1.Suppliers, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SuspendLayout()
            '
            'btnProducts
            '
            Me.btnProducts.Location = New System.Drawing.Point(240, 48)
            Me.btnProducts.Name = "btnProducts"
            Me.btnProducts.Size = New System.Drawing.Size(104, 23)
            Me.btnProducts.TabIndex = 1
            Me.btnProducts.Text = "List Products"
            '
            'btnListProductByCountry
            '
            Me.btnListProductByCountry.Location = New System.Drawing.Point(376, 112)
            Me.btnListProductByCountry.Name = "btnListProductByCountry"
            Me.btnListProductByCountry.Size = New System.Drawing.Size(232, 23)
            Me.btnListProductByCountry.TabIndex = 8
            Me.btnListProductByCountry.Text = "List Products by Supplier by Country (Rel)"
            '
            'cboCountries
            '
            Me.cboCountries.DropDownWidth = 200
            Me.cboCountries.Location = New System.Drawing.Point(16, 16)
            Me.cboCountries.Name = "cboCountries"
            Me.cboCountries.Size = New System.Drawing.Size(200, 21)
            Me.cboCountries.TabIndex = 2
            Me.cboCountries.Text = "{All Countries}"
            '
            'DataGrid1
            '
            Me.DataGrid1.DataMember = ""
            Me.DataGrid1.Location = New System.Drawing.Point(16, 152)
            Me.DataGrid1.Name = "DataGrid1"
            Me.DataGrid1.Size = New System.Drawing.Size(608, 272)
            Me.DataGrid1.TabIndex = 4
            '
            'btnDataView
            '
            Me.btnDataView.Location = New System.Drawing.Point(376, 48)
            Me.btnDataView.Name = "btnDataView"
            Me.btnDataView.Size = New System.Drawing.Size(200, 23)
            Me.btnDataView.TabIndex = 6
            Me.btnDataView.Text = "DataView Suppliers by Country"
            '
            'btnQuery
            '
            Me.btnQuery.Location = New System.Drawing.Point(376, 16)
            Me.btnQuery.Name = "btnQuery"
            Me.btnQuery.Size = New System.Drawing.Size(200, 23)
            Me.btnQuery.TabIndex = 3
            Me.btnQuery.Text = "List Suppliers by Country"
            '
            'btnQuery2
            '
            Me.btnQuery2.Location = New System.Drawing.Point(376, 80)
            Me.btnQuery2.Name = "btnQuery2"
            Me.btnQuery2.Size = New System.Drawing.Size(232, 23)
            Me.btnQuery2.TabIndex = 5
            Me.btnQuery2.Text = "List Products by Supplier by Country (SQL)"
            '
            'btnUpdate
            '
            Me.btnUpdate.Location = New System.Drawing.Point(240, 80)
            Me.btnUpdate.Name = "btnUpdate"
            Me.btnUpdate.Size = New System.Drawing.Size(104, 23)
            Me.btnUpdate.TabIndex = 7
            Me.btnUpdate.Text = "Update Products"
            '
            'btnSuppliers
            '
            Me.btnSuppliers.Location = New System.Drawing.Point(240, 16)
            Me.btnSuppliers.Name = "btnSuppliers"
            Me.btnSuppliers.Size = New System.Drawing.Size(104, 23)
            Me.btnSuppliers.TabIndex = 0
            Me.btnSuppliers.Text = "List Suppliers"
            '
            'btnXML
            '
            Me.btnXML.Location = New System.Drawing.Point(240, 112)
            Me.btnXML.Name = "btnXML"
            Me.btnXML.Size = New System.Drawing.Size(104, 23)
            Me.btnXML.TabIndex = 9
            Me.btnXML.Text = "XML"
            '
            'SqlDataAdapter1
            '
            Me.SqlDataAdapter1.DeleteCommand = Me.SqlDeleteCommand1
            Me.SqlDataAdapter1.InsertCommand = Me.SqlInsertCommand1
            Me.SqlDataAdapter1.SelectCommand = Me.SqlSelectCommand1
            Me.SqlDataAdapter1.TableMappings.AddRange(New System.Data.Common.DataTableMapping() {New System.Data.Common.DataTableMapping("Table", "Suppliers", New System.Data.Common.DataColumnMapping() {New System.Data.Common.DataColumnMapping("SupplierID", "SupplierID"), New System.Data.Common.DataColumnMapping("CompanyName", "CompanyName"), New System.Data.Common.DataColumnMapping("ContactName", "ContactName"), New System.Data.Common.DataColumnMapping("ContactTitle", "ContactTitle"), New System.Data.Common.DataColumnMapping("Address", "Address"), New System.Data.Common.DataColumnMapping("City", "City"), New System.Data.Common.DataColumnMapping("Region", "Region"), New System.Data.Common.DataColumnMapping("PostalCode", "PostalCode"), New System.Data.Common.DataColumnMapping("Country", "Country"), New System.Data.Common.DataColumnMapping("Phone", "Phone"), New System.Data.Common.DataColumnMapping("Fax", "Fax"), New System.Data.Common.DataColumnMapping("HomePage", "HomePage")})})
            Me.SqlDataAdapter1.UpdateCommand = Me.SqlUpdateCommand1
            '
            'SqlSelectCommand1
            '
            Me.SqlSelectCommand1.CommandText = "SELECT SupplierID, CompanyName, ContactName, ContactTitle, Address, City, Region," & _
            " PostalCode, Country, Phone, Fax, HomePage FROM Suppliers"
            Me.SqlSelectCommand1.Connection = Me.SqlConnection1
            '
            'SqlInsertCommand1
            '
            Me.SqlInsertCommand1.CommandText = "INSERT INTO Suppliers(CompanyName, ContactName, ContactTitle, Address, City, Regi" & _
            "on, PostalCode, Country, Phone, Fax, HomePage) VALUES (@CompanyName, @ContactNam" & _
            "e, @ContactTitle, @Address, @City, @Region, @PostalCode, @Country, @Phone, @Fax," & _
            " @HomePage); SELECT SupplierID, CompanyName, ContactName, ContactTitle, Address," & _
            " City, Region, PostalCode, Country, Phone, Fax, HomePage FROM Suppliers WHERE (S" & _
            "upplierID = @@IDENTITY)"
            Me.SqlInsertCommand1.Connection = Me.SqlConnection1
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@CompanyName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "CompanyName", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ContactName", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactName", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ContactTitle", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactTitle", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Address", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Address", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@City", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "City", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Region", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Region", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@PostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "PostalCode", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Country", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Country", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Phone", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Phone", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Fax", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Fax", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlInsertCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@HomePage", System.Data.SqlDbType.NText, 16, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "HomePage", System.Data.DataRowVersion.Current, Nothing))
            '
            'SqlUpdateCommand1
            '
            Me.SqlUpdateCommand1.CommandText = "UPDATE Suppliers SET CompanyName = @CompanyName, ContactName = @ContactName, Cont" & _
            "actTitle = @ContactTitle, Address = @Address, City = @City, Region = @Region, Po" & _
            "stalCode = @PostalCode, Country = @Country, Phone = @Phone, Fax = @Fax, HomePage" & _
            " = @HomePage WHERE (SupplierID = @Original_SupplierID) AND (Address = @Original_" & _
            "Address OR @Original_Address1 IS NULL AND Address IS NULL) AND (City = @Original" & _
            "_City OR @Original_City1 IS NULL AND City IS NULL) AND (CompanyName = @Original_" & _
            "CompanyName) AND (ContactName = @Original_ContactName OR @Original_ContactName1 " & _
            "IS NULL AND ContactName IS NULL) AND (ContactTitle = @Original_ContactTitle OR @" & _
            "Original_ContactTitle1 IS NULL AND ContactTitle IS NULL) AND (Country = @Origina" & _
            "l_Country OR @Original_Country1 IS NULL AND Country IS NULL) AND (Fax = @Origina" & _
            "l_Fax OR @Original_Fax1 IS NULL AND Fax IS NULL) AND (HomePage LIKE @Original_Ho" & _
            "mePage OR @Original_HomePage1 IS NULL AND HomePage IS NULL) AND (Phone = @Origin" & _
            "al_Phone OR @Original_Phone1 IS NULL AND Phone IS NULL) AND (PostalCode = @Origi" & _
            "nal_PostalCode OR @Original_PostalCode1 IS NULL AND PostalCode IS NULL) AND (Reg" & _
            "ion = @Original_Region OR @Original_Region1 IS NULL AND Region IS NULL); SELECT " & _
            "SupplierID, CompanyName, ContactName, ContactTitle, Address, City, Region, Posta" & _
            "lCode, Country, Phone, Fax, HomePage FROM Suppliers WHERE (SupplierID = @Select2" & _
            "_SupplierID)"
            Me.SqlUpdateCommand1.Connection = Me.SqlConnection1
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@CompanyName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "CompanyName", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ContactName", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactName", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ContactTitle", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactTitle", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Address", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Address", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@City", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "City", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Region", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Region", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@PostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "PostalCode", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Country", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Country", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Phone", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Phone", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Fax", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Fax", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@HomePage", System.Data.SqlDbType.NText, 16, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "HomePage", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_SupplierID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "SupplierID", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Address", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Address", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Address1", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Address", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_City", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "City", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_City1", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "City", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_CompanyName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "CompanyName", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ContactName", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactName", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ContactName1", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactName", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ContactTitle", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactTitle", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_ContactTitle1", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactTitle", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Country", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Country", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Country1", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Country", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Fax", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Fax", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Fax1", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Fax", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_HomePage", System.Data.SqlDbType.NText, 16, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "HomePage", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_HomePage1", System.Data.SqlDbType.NText, 16, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "HomePage", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Phone", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Phone", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Phone1", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Phone", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_PostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "PostalCode", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_PostalCode1", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "PostalCode", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Region", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Region", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Original_Region1", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Region", System.Data.DataRowVersion.Original, Nothing))
            Me.SqlUpdateCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Select2_SupplierID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "SupplierID", System.Data.DataRowVersion.Current, Nothing))
            '
            'SqlDeleteCommand1
            '
            Me.SqlDeleteCommand1.CommandText = "DELETE FROM Suppliers WHERE (SupplierID = @SupplierID) AND (Address = @Address OR" & _
            " @Address1 IS NULL AND Address IS NULL) AND (City = @City OR @City1 IS NULL AND " & _
            "City IS NULL) AND (CompanyName = @CompanyName) AND (ContactName = @ContactName O" & _
            "R @ContactName1 IS NULL AND ContactName IS NULL) AND (ContactTitle = @ContactTit" & _
            "le OR @ContactTitle1 IS NULL AND ContactTitle IS NULL) AND (Country = @Country O" & _
            "R @Country1 IS NULL AND Country IS NULL) AND (Fax = @Fax OR @Fax1 IS NULL AND Fa" & _
            "x IS NULL) AND (HomePage LIKE @HomePage OR @HomePage1 IS NULL AND HomePage IS NU" & _
            "LL) AND (Phone = @Phone OR @Phone1 IS NULL AND Phone IS NULL) AND (PostalCode = " & _
            "@PostalCode OR @PostalCode1 IS NULL AND PostalCode IS NULL) AND (Region = @Regio" & _
            "n OR @Region1 IS NULL AND Region IS NULL)"
            Me.SqlDeleteCommand1.Connection = Me.SqlConnection1
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@SupplierID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "SupplierID", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Address", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Address", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Address1", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Address", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@City", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "City", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@City1", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "City", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@CompanyName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, False, CType(0, Byte), CType(0, Byte), "CompanyName", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ContactName", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactName", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ContactName1", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactName", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ContactTitle", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactTitle", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@ContactTitle1", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "ContactTitle", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Country", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Country", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Country1", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Country", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Fax", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Fax", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Fax1", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Fax", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@HomePage", System.Data.SqlDbType.NText, 16, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "HomePage", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@HomePage1", System.Data.SqlDbType.NText, 16, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "HomePage", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Phone", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Phone", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Phone1", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Phone", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@PostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "PostalCode", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@PostalCode1", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "PostalCode", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Region", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Region", System.Data.DataRowVersion.Current, Nothing))
            Me.SqlDeleteCommand1.Parameters.Add(New System.Data.SqlClient.SqlParameter("@Region1", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, True, CType(0, Byte), CType(0, Byte), "Region", System.Data.DataRowVersion.Current, Nothing))
            '
            'SqlConnection1
            '
            Me.SqlConnection1.ConnectionString = "data source=ZORC1WKTU1\ZORC1WKTU1_SQL1;initial catalog=Northwind;persist security" & _
            " info=False;user id=sa;workstation id=ZORC1WKTU1;packet size=4096"
            '
            'DsSuppliers1
            '
            Me.DsSuppliers1.DataSetName = "dsSuppliers"
            Me.DsSuppliers1.Locale = New System.Globalization.CultureInfo("en-US")
            Me.DsSuppliers1.Namespace = "http://www.tempuri.org/dsSuppliers.xsd"
            '
            'DsSuppliers1.Suppliers
            '
            Me.DsSuppliers1.Suppliers.TableName = "Suppliers"
            '
            'Form1
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(640, 445)
            Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnXML, Me.btnListProductByCountry, Me.btnUpdate, Me.btnDataView, Me.btnQuery2, Me.DataGrid1, Me.btnQuery, Me.cboCountries, Me.btnProducts, Me.btnSuppliers})
            Me.Name = "Form1"
            Me.Text = "NorthWind Suppliers and Products"
            CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
            Me.DataGrid1.ResumeLayout(False)
            CType(Me.DsSuppliers1.Suppliers, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.DsSuppliers1, System.ComponentModel.ISupportInitialize).EndInit()
            Me.ResumeLayout(False)

        End Sub

#End Region

        Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

            ' Fill the combo box with ONE of these 2 function calls
            'Call FillComboBoxFromDataReader()
            Call FillComboBoxFromDataSet()

            btnUpdate.Visible = False ' Update Products: display this button only when products are retrieved

            Call IterateThroughProducts() ' Writes to console only

        End Sub

        Private Function IterateThroughProducts()

            ' Purpose: Demonstrate how to work with DataTable, DataColumn and DataRow objects
            ' Use the Products Table as an example

            Dim dsSuppliers As DataSet
            Dim dtTable As DataTable
            Dim dtColumn As DataColumn
            Dim dtRow As DataRow

            Dim strCountry As String

            strCountry = cboCountries.Text.ToString

            ' Retrieve DataSet
            dsSuppliers = ListProducts()

            ' Iterate through DataTables in DataSet
            For Each dtTable In dsSuppliers.Tables

                Console.WriteLine("TABLE: " & dtTable.TableName.ToString & ", #COLUMNS: " & dtTable.Columns.Count)

                ' Iterate through DataColumns in DataSet
                For Each dtColumn In dsSuppliers.Tables("Products").Columns
                    Console.WriteLine("COLUMN: " & dtColumn.ColumnName.ToString & ", DATATYPE: " & dtColumn.DataType.ToString)
                Next

            Next

            ' Iterate through DataRows in DataSet
            'For Each dtColumn In dsSuppliers.Tables("Products").Rows
            '    Console.WriteLine("ROW: " & dtColumn.ColumnName.ToString & ", DATATYPE: " & dtColumn.DataType.ToString)
            'Next

        End Function

        Private Function FillComboBoxFromDataReader()

            ' Purpose:  Populate the combo box with countries list, from a DataReader

            ' OPTION #1

            Dim sqlConn As SqlConnection        ' Form-level connection object
            Dim drCountries As SqlDataReader    ' Form-level DataReader object

            ' Create a new connection object
            sqlConn = New SqlConnection(SQL_CONNECTION)

            ' Load list of countries into the combo box, from the DataReader
            Call ListCountriesInDataReader(sqlConn, drCountries)

            ' Populate the combo box, cboCountries, with the DataReader output
            Do While drCountries.Read()
                ' Do something with the row
                cboCountries.Items.Add(drCountries.Item("Country").ToString())
            Loop

            ' Close DataReader and Connection objects
            drCountries.Close()

            ' Close the connection
            sqlConn.Close()

        End Function

        Private Function FillComboBoxFromDataSet()

            ' Purpose:  Populate the combo box with countries list, from a DataSet

            Dim dsCountries As DataSet          ' Form-level DataSet object
            Dim dsRow As System.Data.DataRow    ' Form-level DataRow object

            ' Load list of countries into the combo box, from the DataSet
            dsCountries = ListCountriesInDataSet()

            ' Populate the combo box, cboCountries, with the DataReader output
            ' Method #1
            'For Each dsRow In dsCountries.Tables(0).Rows
            '    cboCountries.Items.Add(dsRow("Country").ToString())
            'Next

            ' Method #2 (Alternative)
            ' Bind the combo box, cboCountries, to the DataSet
            cboCountries.DataSource = dsCountries.Tables("Countries")
            cboCountries.DisplayMember = "Country"

        End Function

        Public Function ListSuppliers() As DataSet

            ' Purpose:  Return list of Suppliers, in a DataSet object
            ' Notes:    Return all Suppliers by default, if no supplier ID is specified

            Dim sqlConn As SqlConnection
            Dim sqlCmd As SqlCommand
            Dim sqlAdapt As SqlDataAdapter
            Dim rowDataSet As New DataSet()

            Try
                ' Create a new connection object
                sqlConn = New SqlConnection(SQL_CONNECTION)

                ' Create a new command object
                sqlCmd = New SqlCommand()

                ' Specify the command to be executed
                With sqlCmd
                    .Connection = sqlConn
                    .CommandType = CommandType.Text
                    .CommandText = SQL_SUPPLIERS
                    ' Use this line to raise an exception:
                    '.CommandText = "select * from SUPPLIERS2"
                End With

                ' Open the connection
                sqlConn.Open()

                ' Open a DataAdapter object, using the command object
                sqlAdapt = New SqlDataAdapter(sqlCmd)

                ' Populate the DataSet from the DataAdapter
                Call sqlAdapt.Fill(rowDataSet, "Suppliers")

                '' Code to access the untyped DataSet, rowDataSet
                'Console.WriteLine(rowDataSet.Tables("Suppliers").Rows(0).Item("SupplierID").ToString)
                'Console.WriteLine(rowDataSet.Tables("Suppliers").Rows(0).Item("CompanyName").ToString)

                '' Code to access the typed DataSet, dsSuppliers
                'Dim drSuppliers As dsSuppliers.SuppliersDataTable
                'Dim rowSuppliers As dsSuppliers.SuppliersRow

                '' Write out the CompanyName of the first record in the Suppliers table
                'Console.WriteLine(drSuppliers(0).CompanyName())

                '' Write out the datatype of the SupplierID column
                'Console.WriteLine(drSuppliers.SupplierIDColumn.DataType())

                '' Assign the first record in the typed DataSet, to a "Suppliers" Data Row
                'rowSuppliers = drSuppliers(0)
                'Console.WriteLine(rowSuppliers.CompanyName)

            Catch e As SqlException
                Dim colErrors As SqlErrorCollection = e.Errors
                Dim i As Integer
                For i = 0 To colErrors.Count
                    Console.WriteLine("Error #" & e.Number & "[" & e.Source & "] " & _
                    e.Message & ControlChars.CrLf & "Raised from stack trace: " & e.StackTrace)
                Next

                'MsgBox("Error " & e.Number & ": " & e.Message & " [" & e.Source & "]")

            Finally

                sqlConn.Close()

            End Try

            Return (rowDataSet)

        End Function

        Public Function ListSuppliersAsXML() As DataSet

            ' Purpose:  Return list of Suppliers, in a DataSet object
            ' Notes:    Return all Suppliers by default, if no supplier ID is specified

            Dim sqlConn As SqlConnection
            Dim sqlCmd As SqlCommand
            Dim sqlAdapt As SqlDataAdapter
            Dim rowDataSet As New DataSet()

            Try
                ' Create a new connection object
                sqlConn = New SqlConnection(SQL_CONNECTION)

                ' Create a new command object
                sqlCmd = New SqlCommand()

                ' Specify the command to be executed
                With sqlCmd
                    .Connection = sqlConn
                    .CommandType = CommandType.Text
                    .CommandText = SQL_SUPPLIERS
                End With

                ' Open the connection
                sqlConn.Open()

                ' Open a DataAdapter object, using the command object
                sqlAdapt = New SqlDataAdapter(sqlCmd)

                ' Populate the DataSet from the DataAdapter
                Call sqlAdapt.Fill(rowDataSet, "Suppliers")

                'Load the document with the DataSet.
                Dim doc As XmlDataDocument = New XmlDataDocument(rowDataSet)

                'Display the XmlDataDocument.
                doc.Save(Console.Out)

                'Dim MyXmlDoc As System.Xml.XmlReader
                'MyXmlDoc = New System.Xml.XmlTextReader()
                'YourXmlDoc = New System.Xml.XmlNodeReader()

            Catch e As SqlException

                MsgBox("Error " & e.Number & ": " & e.Message & " [" & e.Source & "]")

            Finally

                sqlConn.Close()

            End Try

            Return (rowDataSet)

        End Function

        Public Function ListProducts() As DataSet

            ' Purpose:  Return list of Products, in a DataSet object
            ' Notes:    Return all Products by default, if no Product ID is specified

            Dim sqlConn As SqlConnection
            Dim sqlCmd As SqlCommand
            Dim sqlAdapt As SqlDataAdapter
            Dim rowDataSet As New DataSet()

            Try
                ' Create a new connection object
                sqlConn = New SqlConnection(SQL_CONNECTION)

                ' Create a new command object
                sqlCmd = New SqlCommand()

                ' Specify the command to be executed
                With sqlCmd
                    .Connection = sqlConn
                    .CommandType = CommandType.Text
                    .CommandText = SQL_PRODUCTS
                End With

                ' Open the connection
                sqlConn.Open()

                ' Open a DataAdapter object, using the command object
                sqlAdapt = New SqlDataAdapter(sqlCmd)

                ' Populate the DataSet from the DataAdapter
                Call sqlAdapt.Fill(rowDataSet, "Products")

            Catch e As SqlException

                MsgBox("Error " & e.Number & ": " & e.Message & " [" & e.Source & "]")

            Finally

                sqlConn.Close()

            End Try

            Return (rowDataSet)

        End Function

        Public Function RunQuery(ByVal strSQL As String, _
                                    ByVal strCountry As String) As DataSet

            ' Purpose:  Run queries, using specified SQL statement and Country
            ' Return:   Results in a DataSet object

            Dim sqlConn As SqlConnection
            Dim sqlCmd As SqlCommand
            Dim sqlAdapt As SqlDataAdapter
            Dim rowDataSet As New DataSet()

            Try
                ' Create a new connection object
                sqlConn = New SqlConnection(SQL_CONNECTION)

                ' Create a new command object
                sqlCmd = New SqlCommand()

                ' Specify the command to be executed
                With sqlCmd
                    .Connection = sqlConn
                    .CommandType = CommandType.Text
                    '.CommandText = SQL_SUPPLIERS_BY_COUNTRY
                    ' Substitute the selected country for the @ symbol in the SQL statement
                    .CommandText = Replace(strSQL, "@", strCountry)
                    '.CommandText = Replace(SQL_SUPPLIERS_BY_COUNTRY, "@", strCountry)
                End With

                ' Open the connection
                sqlConn.Open()

                ' Open a DataAdapter object, using the command object
                sqlAdapt = New SqlDataAdapter(sqlCmd)

                ' Populate the DataSet from the DataAdapter
                Call sqlAdapt.Fill(rowDataSet, "SuppliersByCountry")

            Catch e As SqlException

                MsgBox("Error " & e.Number & ": " & e.Message & " [" & e.Source & "]")

            Finally

                sqlConn.Close()

            End Try

            Return (rowDataSet)

        End Function

        Public Function ListCountriesInDataReader(ByVal vSqlConn As SqlClient.SqlConnection, _
                        ByRef drResults As SqlClient.SqlDataReader) ' As SqlClient.SqlDataReader

            ' Purpose:  Return the Supplier Countries, in a DataReader

            Dim sqlCmd As SqlCommand
            Dim rowReader As SqlDataReader

            Try
                ' Create a new command object
                sqlCmd = New SqlCommand(SQL_COUNTRIES, vSqlConn)

                ' Open the connection, if required
                If vSqlConn.State = ConnectionState.Closed Then vSqlConn.Open()

                ' Execute the command and retrieve the records in the DataReader
                drResults = sqlCmd.ExecuteReader(CommandBehavior.SingleResult)  ' Assign results to passed-in DataReader object

                ' Write DataReader contents to the console
                ' Note, the DataReader must be reinitialized once you have looped through it
                ' This code is commented out, otherwise ListCountries() will not return an open DataReader
                'Do While rowReader.Read
                '    Console.WriteLine(rowReader.Item("Country").ToString())
                'Loop
            Catch e As SqlException

                MsgBox("Error " & e.Number & ": " & e.Message & " [" & e.Source & "]")

            Finally

                'vSqlConn.Close() ' Don't need the connection anymore

            End Try

            'Return (rowReader)

        End Function

        Public Function ListCountriesInDataSet() As System.Data.DataSet

            ' Purpose:  Return the Supplier Countries, in a DataSet

            Dim sqlConn As SqlConnection
            Dim sqlCmd As SqlCommand
            Dim sqlAdapt As SqlDataAdapter
            Dim rowDataSet As New DataSet("ListOfCountries") ' New Dataset, named
            Dim strConn As String
            Dim strSQL1, strSQL2, strSQL3, strSQL4 As String

            strConn = "Data Source=ZORC1WKTU1\ZORC1WKTU1_SQL1;" & _
                        "Initial Catalog=Northwind;User ID=sa;"

            strSQL1 = "SELECT DISTINCT Suppliers.Country FROM Suppliers"

            Try
                ' Create a new connection object
                sqlConn = New SqlConnection(strConn)

                ' Create a new command object
                sqlCmd = New SqlCommand()

                ' Specify the command to be executed
                With sqlCmd
                    .Connection = sqlConn
                    .CommandType = CommandType.Text
                    .CommandText = strSQL1
                End With

                ' Open the connection
                sqlConn.Open()

                ' Open a DataAdapter object, using the command object
                sqlAdapt = New SqlDataAdapter(sqlCmd)

                ' Execute the command and retrieve the records in the DataSet
                ' The DataTable is named "Countries"
                Call sqlAdapt.Fill(rowDataSet, "Countries")

            Catch e As SqlException

                MsgBox("Error " & e.Number & ": " & e.Message & " [" & e.Source & "]")

            Finally

                sqlConn.Close() ' Don't need the connection anymore

            End Try

            Return (rowDataSet)

        End Function



        Private Sub btnSuppliers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSuppliers.Click

            ' Purpose: Populate the DataGrid with Suppliers

            Dim dsSuppliers As DataSet

            dsSuppliers = ListSuppliers()

            DataGrid1.DataSource = dsSuppliers

            btnUpdate.Visible = False

        End Sub

        Private Sub btnProducts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProducts.Click

            ' Purpose: Populate the DataGrid with Products

            Dim dsProducts As DataSet

            dsProducts = ListProducts()

            DataGrid1.DataSource = dsProducts

            btnUpdate.Visible = True

        End Sub

        Private Sub btnQuery_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuery.Click

            ' Purpose: Populate the DataGrid with Suppliers by (selected) Country

            Dim dsSuppliersByCountry As DataSet
            Dim strCountry As String

            strCountry = cboCountries.Text.ToString

            'dsSuppliersByCountry = ListSuppliersByCountry(strCountry)
            dsSuppliersByCountry = RunQuery(SQL_SUPPLIERS_BY_COUNTRY, strCountry)

            ' Populate DataGrid with the DataSet
            DataGrid1.DataSource = dsSuppliersByCountry

            btnUpdate.Visible = False

        End Sub

        Private Sub btnQuery2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuery2.Click

            ' Purpose: Populate the DataGrid with Products and Suppliers by (selected) Country

            Dim dsSuppliersProductsByCountry As DataSet
            Dim strCountry As String

            strCountry = cboCountries.Text.ToString

            'dsSuppliersByCountry = ListSuppliersByCountry(strCountry)
            'dsSuppliersProductsByCountry = RunQuery(SQL_SUPPLIERS_AND_PRODUCTS_BY_COUNTRY, strCountry)
            dsSuppliersProductsByCountry = ListSuppliersAndProducts()

            ' Populate DataGrid with the DataSet
            DataGrid1.DataSource = dsSuppliersProductsByCountry

            btnUpdate.Visible = False

        End Sub

        Private Sub btnDataView_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDataView.Click

            ' Purpose: Populate the DataGrid with Suppliers using a DataView by (selected) Country

            Dim dsSuppliers As DataSet
            Dim dsDataView As DataView
            Dim strCountry As String

            strCountry = cboCountries.Text.ToString

            dsSuppliers = ListSuppliers()

            ' Construct DataView, filtered by selected country
            dsDataView = New DataView(dsSuppliers.Tables("Suppliers"))
            'dsDataView.RowFilter = "Country Like 'Fr*'"
            dsDataView.RowFilter = "Country Like '" & strCountry & "*'"

            ' Sort DataView, by Supplier CompanyName ASC
            ' Note, this will add a sort arrow to the datagrid for this field
            dsDataView.Sort = "CompanyName ASC"

            ' Populate DataGrid with the DataView
            DataGrid1.DataSource = dsDataView ' dsSuppliers

            btnUpdate.Visible = False

        End Sub

        Private Sub btnListProductByCountry_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnListProductByCountry.Click

            ' Purpose: Populate the DataGrid with Suppliers and Products, by Country

            Dim dsSuppliersProducts As DataSet
            Dim rowSupplier As DataRow
            Dim rowProduct As DataRow
            Dim strCountry As String

            ' Retrieve the selected country from the combo box
            strCountry = cboCountries.Text.ToString

            'dsSuppliersProducts = ListSuppliersAndProductsByCountry(strCountry)
            dsSuppliersProducts = ListSuppliersAndProducts()

            DataGrid1.DataSource = dsSuppliersProducts

            ' Write DataRelation information, to the console
            For Each rowSupplier In dsSuppliersProducts.Tables("Suppliers").Rows

                If rowSupplier.Item("Country") = strCountry Then

                    ' Write out the SupplierID from the next record in the Supplier table
                    Console.WriteLine("SupplierID: " & rowSupplier("SupplierID"))

                    ' Write out associated information in the Products table
                    For Each rowProduct In rowSupplier.GetChildRows("SuppliersToProducts")
                        Console.WriteLine("Product: " & rowProduct("ProductName"))
                    Next

                End If

            Next

            btnUpdate.Visible = False

        End Sub

        'Public Function ListSuppliersAndProductsByCountry(ByVal strCountry As String) As DataSet
        Public Function ListSuppliersAndProducts() As DataSet

            ' Purpose:  Return list of Suppliers AND Products, by Country,
            ' in a DataSet object, with multiple resultsets

            Dim sqlConn As SqlConnection
            Dim sqlCmdSuppliers As SqlCommand
            Dim sqlCmdProducts As SqlCommand
            Dim sqlAdaptSuppliers As SqlDataAdapter
            Dim sqlAdaptProducts As SqlDataAdapter
            Dim rowDataSet As New DataSet()

            Try
                ' Create a new connection object
                sqlConn = New SqlConnection(SQL_CONNECTION)

                ' Assign Command object per table
                sqlCmdProducts = New SqlCommand(SQL_PRODUCTS, sqlConn)
                sqlCmdSuppliers = New SqlCommand(SQL_SUPPLIERS, sqlConn)

                ' Open the connection
                sqlConn.Open()

                ' Open DataAdapter objects, using the command objects
                sqlAdaptSuppliers = New SqlDataAdapter(sqlCmdSuppliers)
                sqlAdaptProducts = New SqlDataAdapter(sqlCmdProducts)

                ' Populate the DataSet from the DataAdapters
                Call sqlAdaptSuppliers.Fill(rowDataSet, "Suppliers")
                Call sqlAdaptProducts.Fill(rowDataSet, "Products")

                ' Write both resultsets to the console, to demonstrate

                ' Define a DataRelation between Suppliers and Products, on SupplierID
                Dim relSuppliersToProducts As New DataRelation("SuppliersToProducts", _
                    rowDataSet.Tables("Suppliers").Columns("SupplierID"), _
                    rowDataSet.Tables("Products").Columns("SupplierID"))

                rowDataSet.Relations.Add(relSuppliersToProducts)

            Catch e As SqlException

                MsgBox("Error " & e.Number & ": " & e.Message & " [" & e.Source & "]")

            Finally

                sqlConn.Close()

            End Try

            Return (rowDataSet)

        End Function

        Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click

            ' Purpose: Examine changes to the Product DataSet
            Dim dsProducts As DataSet
            Dim rowData As DataRow

            dsProducts = DataGrid1.DataSource

            ' Display Table Name
            Console.WriteLine(dsProducts.Tables(0).TableName)

            ' Edit Product Code
            ' Iterate through all rows, and look for differences between Original and Current records
            ' If there is a difference, then edit the row
            For Each rowData In dsProducts.Tables(0).Rows

                Console.WriteLine("Original: " & rowData.Item("ProductName", DataRowVersion.Original))
                Console.WriteLine("Current: " & rowData.Item("ProductName", DataRowVersion.Current))

                ' If Original RowData <> Current RowData, then edit row value
                If rowData.Item("ProductName", DataRowVersion.Original) <> _
                    rowData.Item("ProductName", DataRowVersion.Current) Then
                    rowData.BeginEdit()
                    rowData.Item("ProductName") = _
                        rowData.Item("ProductName", DataRowVersion.Current)
                    Console.WriteLine("Proposed: " & rowData.Item("ProductName", DataRowVersion.Proposed))
                    MsgBox("Do you want to change '" & rowData.Item("ProductName", DataRowVersion.Original) & _
                        "' to '" & rowData.Item("ProductName", DataRowVersion.Proposed) & "'?", vbYesNo)
                    If vbYes Then
                        If rowData.HasErrors = False Then
                            rowData.AcceptChanges()
                        Else
                            rowData.CancelEdit()
                        End If
                    Else
                        rowData.CancelEdit()
                    End If
                    rowData.EndEdit()
                End If
            Next

            ' Synchronize the updates to the original data source
            Dim sqlConn As New SqlConnection(SQL_CONNECTION)
            Dim sqlCmd As New SqlCommand(SQL_PRODUCTS, sqlConn)
            Dim sqlAdapter As New SqlDataAdapter()

            ' Set the SelectCommand property, so that the UpdateCommand will be generated automatically
            sqlAdapter.SelectCommand = sqlCmd

            ' Update the data source with the changes
            sqlAdapter.Update(dsProducts, "Products")

            ' Allow editing on first row only
            'dsProducts.Tables(0).Rows(0).BeginEdit()

            ' Display DataRow(0) Original and Proposed ProductNames
            'MsgBox(dsProducts.Tables(0).Rows(0).Item("ProductName", DataRowVersion.Original))
            'MsgBox(dsProducts.Tables(0).Rows(0).Item("ProductName", DataRowVersion.Current))
            'MsgBox(dsProducts.Tables(0).Rows(0).Item("ProductName", DataRowVersion.Proposed))

        End Sub

        Friend WithEvents cboCountries As System.Windows.Forms.ComboBox
        Friend WithEvents btnQuery As System.Windows.Forms.Button
        Friend WithEvents btnProducts As System.Windows.Forms.Button
        Friend WithEvents btnSuppliers As System.Windows.Forms.Button
        Friend WithEvents btnQuery2 As System.Windows.Forms.Button
        Friend WithEvents btnDataView As System.Windows.Forms.Button
        Friend WithEvents btnUpdate As System.Windows.Forms.Button

        Friend WithEvents btnListProductByCountry As System.Windows.Forms.Button

        Private Sub btnXML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnXML.Click


        End Sub
        Friend WithEvents btnXML As System.Windows.Forms.Button
        Friend WithEvents DsSuppliers1 As TestADONetChap2.dsSuppliers
        Friend WithEvents SqlConnection1 As System.Data.SqlClient.SqlConnection
        Friend WithEvents SqlDeleteCommand1 As System.Data.SqlClient.SqlCommand
        Friend WithEvents SqlUpdateCommand1 As System.Data.SqlClient.SqlCommand
        Friend WithEvents SqlInsertCommand1 As System.Data.SqlClient.SqlCommand
        Friend WithEvents SqlSelectCommand1 As System.Data.SqlClient.SqlCommand
        Friend WithEvents SqlDataAdapter1 As System.Data.SqlClient.SqlDataAdapter
    End Class
End Namespace
