Module Module1
    
    Sub Main()
        ' Fill a DataSet with data from the pubs database
        Dim dbConn As New SqlClient.SqlConnection("server=localhost;uid=sa;pwd=;database=pubs")
        Dim da As New SqlClient.SqlDataAdapter("SELECT au_id,au_lname,au_fname,contract FROM authors", dbConn)
        Dim ds As New DataSet("DS")
        Dim ds2 As New DataSet("DS2")

        ' Fill with data and schema
        da.Fill(ds)

        ' Only the schema for the other dataset
        da.FillSchema(ds2, SchemaType.Source)

        ' Print the starting number of rows
        Console.WriteLine("Starting number of rows: {0}", ds.Tables(0).Rows.Count)

        ' Add a new row
        Dim r As DataRow
        r = ds2.Tables(0).NewRow()
        r("au_id") = "222-22-2222"
        r("au_fname") = "Fabio Claudio"
        r("au_lname") = "Ferracchiati"
        r("contract") = True
        ds2.Tables(0).Rows.Add(r)

        ' Merge the two DataSets
        ds.Merge(ds2)

        ' Print the starting number of rows
        Console.WriteLine("Number of rows after the Merge(): {0}", ds.Tables(0).Rows.Count)

    End Sub
    
End Module
