Module Module1
    Dim dbConn As SqlClient.SqlConnection

    Sub PrintErrors(ByVal t As DataTable)
        Dim r() As DataRow = t.GetErrors()
        Dim i As Integer

        For i = 0 To r.Length - 1
            Console.WriteLine("AuthorID: " + r(i)("AuthorID") + " - " + r(i).RowError)
        Next
    End Sub

    Function FindErrorsInTable(ByVal c As Sqlclient.SqlConnection, ByVal t As DataTable) As Boolean
        Dim sql As New System.Data.SqlClient.SqlCommand()
        Dim bError As Boolean = False

        If c.State = ConnectionState.Closed Then c.Open()

        Dim i As Integer = 0
        For i = 0 To t.Rows.Count - 1
            Dim strSQL As String = "SELECT AuthorID FROM tabAuthors WHERE AuthorID=" & t.Rows(i)("AuthorID").ToString()
            sql.CommandText = strSQL
            sql.Connection = c

            Dim reader As System.Data.SqlClient.SqlDataReader = sql.ExecuteReader()
            If reader.Read() Then
                t.Rows(i).RowError = "This value already exists."
                bError = True
            End If
            reader.Close()
        Next

        If c.State = ConnectionState.Open Then c.Close()

        FindErrorsInTable = bError
    End Function

    Sub Main()
        dbConn = New System.Data.SqlClient.SqlConnection("server=localhost;uid=sa;pwd=;database=WroxDB")

        Try
            ' Retrieve the table schema from the Database
            Dim da As New System.Data.SqlClient.SqlDataAdapter("SELECT AuthorID, Author_FirstName, Author_LastName FROM tabAuthors", dbConn)
            Dim dt As New DataTable("WroxAuthors")
            da.FillSchema(dt, SchemaType.Source)

            ' Fill a dataset with XML document records
            Dim ds As New DataSet("NewAuthors")
            ds.ReadXml("C:\\Authors.xml")

            ' Copying data from dataset to datatable
            dt = ds.Tables(0)

            ' Create Insert command automatically
            Dim builder As New System.Data.SqlClient.SqlCommandBuilder(da)

            ' Looks for errors				
            Dim bErrors As Boolean = FindErrorsInTable(dbConn, dt)

            ' If no errors founded Update the table
            ' otherwise print the errors
            If bErrors = False Then
                da.Update(dt)
                dt.AcceptChanges()
                Console.WriteLine("Records are stored successfully")
            Else
                PrintErrors(dt)
                dt.RejectChanges()
            End If
        Catch e As Exception
            Console.WriteLine(e.Message)
        Finally
            If dbConn.State = ConnectionState.Open Then
                dbConn.Close()
            End If
        End Try
    End Sub

End Module
