<%@ Page language="c#" Codebehind="BasicDataGrid.aspx.cs" Inherits="DayOfDotNet.BasicDataGrid" %>
<HTML>
	<body style="font: x-small Verdana, Arial, sans-serif;">
		<!-- Begin Web Form -->
		<form id="BasicDataGrid" method="post" runat="server">
			<p>
				<a href="/ADayOfDotNet/">Parent Directory</a>
			</p>
			<!-- Begin DataGrid -->
			<asp:DataGrid id="BookDataGrid" runat="server" AutoGenerateColumns="False" CellPadding="2" CellSpacing="0" Font-Names="Verdana, Arial, sans-serif" BorderColor="Black" BorderWidth="1" GridLines="Horizontal">
				<HeaderStyle Font-Bold="True" Font-Size="small" Font-Name="Arial" BackColor="Maroon" ForeColor="White" />
				<ItemStyle Font-Size="x-small" />
				<AlternatingItemStyle BackColor="Tan" />
				<Columns>
					<asp:TemplateColumn ItemStyle-VerticalAlign="Top">
						<ItemTemplate>
							<img src='images/<%# DataBinder.Eval(Container.DataItem, "ImageSrc") %>' Alt='<%# DataBinder.Eval(Container.DataItem, "Title" ) %>'>
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:HyperLinkColumn DataTextField="Title" DataNavigateUrlField="AmazonLink" HeaderText="Title" ItemStyle-VerticalAlign="Top" />
					<asp:TemplateColumn ItemStyle-VerticalAlign="Top" HeaderText="Info">
						<ItemTemplate>
							<b>Publisher:</b> <a href='<%# DataBinder.Eval(Container.DataItem, "PublisherURL") %>' target="_blank">
								<%# DataBinder.Eval(Container.DataItem, "PublisherName") %>
							</a>
							<br>
							<b>Release Date:</b>
							<%# DataBinder.Eval(Container.DataItem, "ReleaseDate", "{0:d}") %>
							<br>
							<b>Price:</b>
							<%# DataBinder.Eval(Container.DataItem, "Price", "{0:c}") %>
							<br>
							<b>Description:</b>
							<br>
							<blockquote>
								<%# DataBinder.Eval(Container.DataItem, "Description") %>
							</blockquote>
							<p>
								<a href='<%# DataBinder.Eval(Container.DataItem, "AmazonLink") %>'>Buy Now! </a>
							</p>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:DataGrid>
			<!-- End DataGrid -->
		</form>
		<!-- End Web Form -->
	</body>
</HTML>
