namespace PowerOfDotNet.Clubs
{
	using System;
	using System.IO;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using System.Text.RegularExpressions;
	using System.Configuration;

	/// <summary>
	///		ClubSubMain   Դϴ.
	/// </summary>
	public abstract class ClubSubMain : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.PlaceHolder placehdrClubSubMain;

		// ɺ ڿ 

		#region ɺ ڿ  

		private const string LAYOUT_OPEN = "{{̾ƿ}}";
		private const string LAYOUT_CLOSE = "{{̾ƿ}}";

		private const string CLUB_ID = "{{ŬNO}}";
		private const string CLUB_DIR = "{{Ŭ͸}}";
		private const string CLUB_LOGO = "{{Ŭΰ}}";
		private const string CLUB_SUBJECT = "{{Ŭ}}";
		private const string CLUB_SYSOP_ID = "{{ûID}}";
		private const string CLUB_SYSOP_NAME = "{{û̸}}";
		private const string CLUB_SYSOP_EMAIL = "{{ûEMAIL}}";
		private const string CLUB_SYSOP_EMAIL_SEND_LINK = "{{ûEMAILũ}}";
		private const string CLUB_MEMBER_COUNT = "{{ȸ}}";
		private const string CLUB_CREATED_DATE = "{{}}";
		private const string CLUB_INTRO_HTML = "{{Ұ}}";
		private const string CLUB_CLASS_NAME = "{{з̸}}";
		private const string CLUB_CLASS_IMAGE_PATH = "{{з̹}}";
		private const string CLUB_PUBLIC_TYPE = "{{Ŭ}}";
		private const string CLUB_SELECT_BOARD = "{{ԽǼùڽ}}";
		private const string CLUB_SUB_CLUB_HOME_LINK = "{{ŬȨũ}}";
		private const string CLUB_MEMBER_LIST_LINK = "{{ȸϸũ}}";
		private const string CLUB_JOIN_INFO_MODIFY_LINK = "{{渵ũ}}";
		private const string CLUB_WITHDRAWAL_LINK = "{{ȸŻũ}}";
		private const string CLUB_MANAGEMENT_LINK = "{{Ŭũ}}";


		private const string DEF_CREATED_DATE_BEGIN = "{{ǽ}}";
		private const string DEF_CREATED_DATE_END = "{{ǳ}}";
		private const string DEF_SUB_CLUB_HOME_LINK_BEGIN = "{{ŬȨũǽ}}";
		private const string DEF_SUB_CLUB_HOME_LINK_END = "{{ŬȨũǳ}}";
		private const string DEF_MEMBER_LIST_BEGIN = "{{ȸϸũǽ}}";
		private const string DEF_MEMBER_LIST_END = "{{ȸϸũǳ}}";
		private const string DEF_JOIN_INFO_MODIFY_BEGIN = "{{渵ũǽ}}";
		private const string DEF_JOIN_INFO_MODIFY_END = "{{渵ũǳ}}";
		private const string DEF_CLUB_WITHDRAWAL_BEGIN = "{{ȸŻũǽ}}";
		private const string DEF_CLUB_WITHDRAWAL_END = "{{ȸŻũǳ}}";
		private const string DEF_CLUB_MANAGEMENT_BEGIN = "{{Ŭũǽ}}";
		private const string DEF_CLUB_MANAGEMENT_END = "{{Ŭũǳ}}";

		/* Խ   */
		//԰ ȣ ٸ üִ.
		private const string CLUB_BOARD_F = "{{ŬԽ";
		private const string CLUB_BOARD_SUBJECT_E = "}}";

		#endregion

		#region   

		private int _clubId;
		private string _clubDir;
		private string _subject;
		private string _sysopId;
		private string _sysopName;
		private string _sysopEmail;
		private int _memberCount;
		private DateTime _CreatedDate;
		private string _introHtml;
		private int _classId;
		private string _className;
		private string _classImagePath;
		private string _publicType;

		private string _sendEmailLink;
		//private string _sendMessageLink;

		//  Ʈ
		private DropDownList _drpdnlstMenuList;
		private HyperLink _hyplnkSubClubHome;
		private HyperLink _hyplnkMemberList;
		private HyperLink _hyplnkJoinInfoModify;
		private HyperLink _hyplnkClubWithdrawal;
		private HyperLink _hyplnkClubManagement;

		//α׷ Ǹ  Ŭ  Ѵ.
		private Hashtable htSymboleSubstance = new Hashtable();
		//RealizeSymbols GetPortion   Ѵ.
		private Hashtable htSymboleDef = new Hashtable();
		//{{ŬԽn}} ִ ڸ Ե 
		//LiteralControl Ʈѵ Ѵ.
		private Hashtable htBoardSubject = new Hashtable();
		private string[] aPublicType = new string[] {"Free", "", ""};

		#endregion

		private void Page_Load(object sender, System.EventArgs e)
		{
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);
			//Ŭ ͸  
			_clubDir = "clubId_" + _clubId.ToString();
			_clubDir = this.Page.MapPath("/Clubs/ClubsDir/" + _clubDir);

			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();

			//SelectedIndexChanged ̺Ʈ ߻ϰ Ϸ
			//if (!this.IsPostBack)  ۿ ־Ѵ.
			_drpdnlstMenuList = new DropDownList();
			SqlDataReader dr = db.GetBoardList(_clubId);
			_drpdnlstMenuList.DataSource = dr;
			_drpdnlstMenuList.DataTextField = "Subject";
			_drpdnlstMenuList.DataValueField = "ID";
			_drpdnlstMenuList.DataBind();
			_drpdnlstMenuList.Items.Insert(0, new ListItem("-- Խ  --", "0"));
			_drpdnlstMenuList.AutoPostBack = true;
			_drpdnlstMenuList.SelectedIndexChanged += new EventHandler(this.drpdnlstMenuList_SelectedIndexChanged);

			if (!this.IsPostBack)
			{
				Components.ClubInfo clubInfo = ClubsUtil.GetClubInfo(this, _clubId);

				_subject = clubInfo.subject;
				_sysopId = clubInfo.sysopId;
				_sysopName = clubInfo.sysopName;
				_sysopEmail = clubInfo.sysopEmail;
				_memberCount = clubInfo.memberCount;
				_CreatedDate = clubInfo.CreatedDate;
				_introHtml = clubInfo.introHtml;
				_classId = clubInfo.classId;
				_publicType = aPublicType[clubInfo.publicType];

				_sendEmailLink = GetLink("Ͼ") + "&mode=send&to=" + Server.UrlEncode(_sysopName + " <" + _sysopEmail + ">");

				_className = clubInfo.className;
				_classImagePath = clubInfo.classImagePath;

				//Ŭ Ȩ, ȸ,  , Ŭ Ż ޴ Ʈ
				_hyplnkSubClubHome = new HyperLink();
				_hyplnkSubClubHome.NavigateUrl = GetLink("Ŭ") + "&clubId=" + _clubId;
				_hyplnkMemberList = new HyperLink();
				_hyplnkMemberList.NavigateUrl = GetLink("Ŭȸ") + "&clubId=" + _clubId;
				_hyplnkJoinInfoModify = new HyperLink();
				_hyplnkJoinInfoModify.NavigateUrl = "javascript:OpenJoinInfoModifyWin(" + _clubId + ",'" + GetLink("Ŭ").Replace("=","^").Replace("&","$") + "')";
				_hyplnkClubWithdrawal = new HyperLink();
				_hyplnkClubWithdrawal.NavigateUrl = "javascript:WithdrawalFromClub(" + _clubId + ",'" + GetLink("Ŭ").Replace("=","^").Replace("&","$") + "')";
				_hyplnkClubManagement = new HyperLink();
				//Ŭ  ڸ   ֵ
				string userId = Page.User.Identity.Name;
				if (userId == _sysopId || Clubs.ClubsUtil.CheckUserIsAdmin(userId )) {
					_hyplnkClubManagement.NavigateUrl = this.GetLink("Ŭ") + "&clubId=" + _clubId;
				}

				htSymboleSubstance.Add(CLUB_ID, _clubId.ToString());
				htSymboleSubstance.Add(CLUB_DIR, _clubDir);
				htSymboleSubstance.Add(CLUB_SUBJECT, _subject);
				htSymboleSubstance.Add(CLUB_SYSOP_ID, _sysopId);
				htSymboleSubstance.Add(CLUB_SYSOP_NAME, _sysopName);
				htSymboleSubstance.Add(CLUB_SYSOP_EMAIL, _sysopEmail);
				htSymboleSubstance.Add(CLUB_SYSOP_EMAIL_SEND_LINK, _sendEmailLink);
				htSymboleSubstance.Add(CLUB_MEMBER_COUNT, _memberCount.ToString());
				htSymboleSubstance.Add(CLUB_CREATED_DATE, _CreatedDate);
				htSymboleSubstance.Add(CLUB_INTRO_HTML, _introHtml);
				htSymboleSubstance.Add(CLUB_CLASS_NAME, _className);
				htSymboleSubstance.Add(CLUB_CLASS_IMAGE_PATH, _classImagePath);
				htSymboleSubstance.Add(CLUB_PUBLIC_TYPE, _publicType);
				htSymboleSubstance.Add(CLUB_SUB_CLUB_HOME_LINK, _hyplnkSubClubHome);
				htSymboleSubstance.Add(CLUB_MEMBER_LIST_LINK, _hyplnkMemberList);
				htSymboleSubstance.Add(CLUB_JOIN_INFO_MODIFY_LINK, _hyplnkJoinInfoModify);
				htSymboleSubstance.Add(CLUB_WITHDRAWAL_LINK, _hyplnkClubWithdrawal);
				htSymboleSubstance.Add(CLUB_MANAGEMENT_LINK, _hyplnkClubManagement);

				string strSkin = String.Empty;

				//Ŭ Ų Ÿ    
				if ((int)clubInfo.skinType == 0) {
					strSkin = clubInfo.mainHtml;
				}
				else {
					//Ʈ ⺻  ϴ Ų 
					//web.config ǵ Ų Ͽ ش 
					//Ų ̸ ´.
					string[] aSkins = ConfigurationSettings.AppSettings["ClubSkinTypes"].Split(new char[] {';'});
					string skinFile = aSkins[(int)clubInfo.skinType - 1].Split(new char[] {'='})[1];

					//ϵ ũ Ų о
					StreamReader sr = new StreamReader(
						(Stream)File.OpenRead(MapPath("/Clubs/" + skinFile)), 
						System.Text.Encoding.Default);
					strSkin = sr.ReadToEnd();
					sr.Close();
				}

				//{{...}} ɺ ˻ϴ Խ 
				Regex skinRegex = new Regex("(?<symbol>{{[^{}]+}})");
				//Խİ ġϴ ڿ  ˻
				MatchCollection mcMain = skinRegex.Matches(strSkin);

				try	{
					//{{DEF_..._BEGIN}} {{DEF_..._END}} ̿ 
					//ǵ ڿ  ˻Ѵ.
					RealizeSymbols(mcMain, strSkin);

					//ä ̾ƿ 
					string clubSubMainTemplate = GetPortion(strSkin, LAYOUT_OPEN, LAYOUT_CLOSE, mcMain);
					if (clubSubMainTemplate == null)
						throw new Exception(LAYOUT_OPEN + "(̳) " + LAYOUT_CLOSE + " ǰ ߸Ǿϴ.");

					//̾ƿ ڿ ȿ ٽ {{...}} ɺ ˻Ѵ.
					MatchCollection mcTemplate = skinRegex.Matches(clubSubMainTemplate);
					if (mcTemplate.Count > 0) {
						for (int i=0; i < mcTemplate.Count; i++) {
							string frontPortion, backPortion;

							//ù° ˻ ù° {{...}} ɺ 
							if (i == 0)	{
								// clubSubMainTemplate  clubSubMainTemplate 
								// i-1 i ɺ  ڿ ´.
								//  ؼ  ɺ ٷ  ɺ   ´.
								frontPortion = GetFrontPortion(clubSubMainTemplate, mcTemplate, i);
								if (frontPortion != String.Empty)
									// ڷ  ڿ LiteralControl Ʈѷ 
									//  ߰Ѵ.
									AddLiteralControlToPage(frontPortion);

								// ڷ  {{...}} ɺ ϴ Ʈ 
								//   ߰Ѵ.
								SetupEachControl(mcTemplate[i]);

								// clubSubMainTemplate  clubSubMainTemplate 
								// i i+1 ɺ °  ڿ ´.
								// ٽøؼ  ɺ ٷ  ɺ  ڿ ´.
								backPortion = GetBackPortion(clubSubMainTemplate, mcTemplate, i);
								if (backPortion != String.Empty)
									AddLiteralControlToPage(backPortion);
							}
							else {//ι° ˻ {{...}} ɺ ʹ Ⱑ ȴ.
								// ڷ  {{...}} ɺ ϴ Ʈ 
								//   ߰Ѵ.								
								SetupEachControl(mcTemplate[i]);

								// clubSubMainTemplate  clubSubMainTemplate 
								// i i+1 ° ɺ  ڿ ´.
								backPortion = GetBackPortion(clubSubMainTemplate, mcTemplate, i);
								if (backPortion != String.Empty)
									AddLiteralControlToPage(backPortion);
							}
						}
					}
				}
				catch (Exception err)
				{
					// ߻  Ų   ֵ 
					// ⺻ Ŭ ޴ ְ  ޼ Ѵ.
					SubClubMenu menu = (SubClubMenu)this.Page.LoadControl("~/Clubs/SubClubMenu.ascx");
					placehdrClubSubMain.Controls.Add(menu);
					placehdrClubSubMain.Controls.Add(new LiteralControl("<br><br><b>Ų ֽϴ.</b><br><br><br>"));
					placehdrClubSubMain.Controls.Add(new LiteralControl(err.Message));
					placehdrClubSubMain.Controls.Add(new LiteralControl("<br><br>"));
				}
			}
			else
			{
				//ݵ ̷  ̺Ʈ ߻Ѵ. 
				placehdrClubSubMain.Controls.Add(_drpdnlstMenuList);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		// Խ ̵Ѵ.
		private void drpdnlstMenuList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			int id = Convert.ToInt32(((DropDownList)sender).SelectedItem.Value);
			Response.Redirect(GetLink("Ŭ_") + "&clubId=" + _clubId + 
				"&TableId=" + id + "&ddlIndex=" + ((DropDownList)sender).SelectedIndex);
		}

		//ڷ־ Match ü Value ִ ɺ 
		// ϴ Ʈ  ߰Ѵ.
		private void SetupEachControl(Match m)
		{
			string symbolName = m.Value;
			string symbolDef;
			HyperLink hl;

			//  ɺ ϴ Ʈ
			//  ߰Ѵ.
			switch (symbolName)
			{
				case CLUB_LOGO :
					// Ŭ ΰ ̹ ũ
					if (File.Exists(_clubDir + "ClubLogo.jpg"))
						AddLiteralControlToPage("<img src='" + _clubDir + "ClubLogo.jpg" + "'>");
					else
						AddLiteralControlToPage("<img src='/Clubs/Images/ClubLogo.jpg'>");
					break;
				case CLUB_CREATED_DATE :
					// Ŭ  
					symbolDef = (string)htSymboleDef[symbolName];
					if (symbolDef == null) {
						DateTime cdt = (DateTime)htSymboleSubstance[symbolName];
						AddLiteralControlToPage(cdt.ToString("yyyy-MM-dd"));
					}
					else {
						DateTime cdt = (DateTime)htSymboleSubstance[symbolName];
						AddLiteralControlToPage(cdt.ToString(symbolDef));
					}
					break;
				case CLUB_SUB_CLUB_HOME_LINK :
					//  Ŭ Ȩ  ũ
					hl = (HyperLink)htSymboleSubstance[symbolName];
					symbolDef = (string)htSymboleDef[symbolName];
					if (symbolDef == null)
						hl.Text = "Ŭ Ȩ";
					else
						hl.Text = symbolDef;

					placehdrClubSubMain.Controls.Add(hl);

					break;
				case CLUB_MEMBER_LIST_LINK :
					// ȸ   ũ
					hl = (HyperLink)htSymboleSubstance[symbolName];
					symbolDef = (string)htSymboleDef[symbolName];
					if (symbolDef == null)
						hl.Text = "ȸ ";
					else
						hl.Text = symbolDef;

					placehdrClubSubMain.Controls.Add(hl);

					break;
				case CLUB_JOIN_INFO_MODIFY_LINK :
					//   â  ũ
					hl = (HyperLink)htSymboleSubstance[symbolName];
					symbolDef = (string)htSymboleDef[symbolName];
					if (symbolDef == null)
						hl.Text = " ";
					else
						hl.Text = symbolDef;

					placehdrClubSubMain.Controls.Add(hl);
					
					break;
				case CLUB_WITHDRAWAL_LINK :
					// Ŭ Ż  ũ
					hl = (HyperLink)htSymboleSubstance[symbolName];
					symbolDef = (string)htSymboleDef[symbolName];
					if (symbolDef == null)
						hl.Text = "Ŭ Ż";
					else
						hl.Text = symbolDef;

					placehdrClubSubMain.Controls.Add(hl);
					break;
				case CLUB_MANAGEMENT_LINK :
					// Ŭ    ũ
					hl = (HyperLink)htSymboleSubstance[symbolName];
					symbolDef = (string)htSymboleDef[symbolName];
					if (symbolDef == null)
						hl.Text = "Ŭ ";
					else
						hl.Text = symbolDef;

					placehdrClubSubMain.Controls.Add(hl);
					break;
				case CLUB_SELECT_BOARD :
					// Խ ϴ DropDownList Ʈ
					placehdrClubSubMain.Controls.Add(_drpdnlstMenuList);
					break;
				default :
					//{{ŬԽn}} ɺ̳ {{ŬԽn}} ɺ̸
					if (symbolName.StartsWith(CLUB_BOARD_F)) {
						//{{ŬԽn}} ɺ ڿ 
						//n λ  ִ ڴ 0~9 .
						string boardSubject = symbolName.Substring(CLUB_BOARD_F.Length, 1);
						boardSubject = CLUB_BOARD_F + boardSubject + CLUB_BOARD_SUBJECT_E;

						// htBoardSubject  ̹  LiteralControl Ʈ 
						// ִ ˾ƺ  Ѵ.
						LiteralControl oBS = (LiteralControl)htBoardSubject[boardSubject];
						if (oBS == null) {
							oBS = new LiteralControl();
							htBoardSubject[boardSubject] = oBS;
						}

						//{{ŬԽn}} ̸
						if (symbolName.EndsWith(CLUB_BOARD_SUBJECT_E)) {
							placehdrClubSubMain.Controls.Add(oBS);
						}
						else {//{{ŬԽn}} ̸
							//FragClubBoard.ascx Ʈ Ѵ.
							// Ʈ Խ Ų ǵ  Ѵ.
							FragClubBoard boardModule = (FragClubBoard) Page.LoadControl("~/Clubs/FragClubBoard.ascx");
							//Ų ڿ 
							boardModule.BoardSkin = (string)htSymboleDef[symbolName];
							//Խ  Ʈ 
							boardModule.SubjectControl = oBS;
							placehdrClubSubMain.Controls.Add(boardModule);
						}
					}
					else {// ׿ Ŭ  ڿ
						string item = (string)htSymboleSubstance[symbolName];
						AddLiteralControlToPage(item);
					}
					break;
			}
		}

		//{{DEF_..._BEGIN}} {{DEF_..._END}} ̿ ǵ ڿ   
		//htSymboleDef  Ѵ.
		private void RealizeSymbols(MatchCollection mc, string strSkin)
		{
			string portion;
			htSymboleDef.Add(CLUB_CREATED_DATE, GetPortion(strSkin, DEF_CREATED_DATE_BEGIN, DEF_CREATED_DATE_END, mc));
			htSymboleDef.Add(CLUB_SUB_CLUB_HOME_LINK, GetPortion(strSkin, DEF_SUB_CLUB_HOME_LINK_BEGIN, DEF_SUB_CLUB_HOME_LINK_END, mc));
			htSymboleDef.Add(CLUB_MEMBER_LIST_LINK, GetPortion(strSkin, DEF_MEMBER_LIST_BEGIN, DEF_MEMBER_LIST_END, mc));
			htSymboleDef.Add(CLUB_JOIN_INFO_MODIFY_LINK, GetPortion(strSkin, DEF_JOIN_INFO_MODIFY_BEGIN, DEF_JOIN_INFO_MODIFY_END, mc));
			htSymboleDef.Add(CLUB_WITHDRAWAL_LINK, GetPortion(strSkin, DEF_CLUB_WITHDRAWAL_BEGIN, DEF_CLUB_WITHDRAWAL_END, mc));
			htSymboleDef.Add(CLUB_MANAGEMENT_LINK, GetPortion(strSkin, DEF_CLUB_MANAGEMENT_BEGIN, DEF_CLUB_MANAGEMENT_END, mc));

			//CLUB_BOARD_F + count + "ǽ}}"  CLUB_BOARD_F + count + "ǳ}}" ̿
			//  ִ coun 0 9 ڴ.
			for (int count=1;count<=9; count++) {
				//
				if ((portion = GetPortion(strSkin, CLUB_BOARD_F + count + "ǽ}}", 
					CLUB_BOARD_F + count + "ǳ}}", mc)) != null) {
					string key = CLUB_BOARD_F + count + "}}";
					htSymboleDef.Add(key, portion);
				}
			}
		}

		// ־ ؽƮ LiteralControl Ʈѷ   ߰
		private void AddLiteralControlToPage(string text)
		{
			placehdrClubSubMain.Controls.Add(new LiteralControl(text));
		}

		// ɺ  ڿ ´.
		private string GetFrontPortion(string origin, MatchCollection mc, int index)
		{
			//index 0̸ ù °̹Ƿ ɺ  ڿ  ȯ
			if (index == 0) {
				//mc[index].Index origin mc[index].Value ġ.
				return origin.Substring(0, mc[index].Index);
			}
			else {
				//origin mc[i-1].Value ɺ mc[i].Value ɺ  ڿ ȯѴ.
				return origin.Substring(mc[index-1].Index+mc[index-1].Length, 
					mc[index].Index - (mc[index-1].Index+mc[index-1].Length));
			}
		}

		// ɺ Ĺ ڿ ´.
		private string GetBackPortion(string origin, MatchCollection mc, int index)
		{
			//index mc.Count-1̸ ̹Ƿ ɺ  ڿ  ȯ
			if (index == mc.Count-1) {
				return origin.Substring(mc[index].Index + mc[index].Length);
			}
			else {
				//mc[index].Index origin mc[index].Value ġ.
				//origin mc[i].Value ɺ mc[i+1].Value ɺ  ڿ ȯѴ.
				return origin.Substring(mc[index].Index + mc[index].Length, 
					mc[index + 1].Index - (mc[index].Index+mc[index].Length));
			}
		}

		//startSymbol enSynbol Ʈ ´.
		private string GetPortion(string origin, string startSymbol, string endSymbol, MatchCollection mc)
		{
			//mc Value  startSymbol Match ü ã ȯ Ѵ.
			Match sm = FindMatche(mc, startSymbol);
			if (sm == null)
				return null;

			//mc Value  endSymbol Match ü ã ȯ Ѵ.
			Match em = FindMatche(mc, endSymbol);
			if (em == null)
				return null;

			int iStart = sm.Index + sm.Length;
			int iLength = em.Index - iStart;

			return origin.Substring(iStart, iLength);
		}

		private Match FindMatche(MatchCollection mc, string search)
		{
			foreach (Match m in mc) {
				if (search == m.Value)
					return m;
			}

			return null;
		}

	}
}
