use AspDotNetBook

go
CREATE TABLE [dbo].[tbDailyPlan] (
	[rtDate] [smalldatetime] NOT NULL, --  0000-00-00 ̷  ð  ¥ Ѵ.
	[rtNote] [text] 
) ON [PRIMARY]

GO

ALTER TABLE [dbo].[tbDailyPlan] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbDailyPlan] PRIMARY KEY  NONCLUSTERED 
	(
		[rtDate]
	)  ON [PRIMARY] 
GO

CREATE PROCEDURE [dbo].[GetRoomStatList]
(
    @startDate smallDateTime,
    @endDate smallDateTime
)
 AS

Select *
 From 
	tbDailyPlan 
where 
	rtDate>=@startDate and rtDate<=@endDate 
Order By rtDate
GO
