using System;
using System.Web;

namespace Chapter08.Ex02
{
	public class Chap08_Ex02 : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			string outputStr = String.Empty;
			string spaceStr = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";

			outputStr += "Accept Type : <br>";
			String[] arr = Request.AcceptTypes;
			for (int i = 0; i < arr.Length; i++)
			{
				outputStr += spaceStr + i +" : " + arr[i] + "<br>";
			}
			outputStr += "<br>";

			outputStr += "Browser Capabilities : <br>";
			HttpBrowserCapabilities bc = Request.Browser;
			outputStr += spaceStr + "Type = " + bc.Type + "<br>";
			outputStr += spaceStr + "Name = " + bc.Browser + "<br>";
			outputStr += spaceStr + "Version = " + bc.Version + "<br>";
			outputStr += spaceStr + "Major Version = " + bc.MajorVersion + "<br>";
			outputStr += spaceStr + "Minor Version = " + bc.MinorVersion + "<br>";
			outputStr += spaceStr + "Platform = " + bc.Platform + "<br>";
			outputStr += spaceStr + "Is Beta = " + bc.Beta + "<br>";
			outputStr += spaceStr + "Is Crawler = " + bc.Crawler + "<br>";
			outputStr += spaceStr + "Is AOL = " + bc.AOL + "<br>";
			outputStr += spaceStr + "Is Win16 = " + bc.Win16 + "<br>";
			outputStr += spaceStr + "Is Win32 = " + bc.Win32 + "<br>";
			outputStr += spaceStr + "Supports Frames = " + bc.Frames + "<br>";
			outputStr += spaceStr + "Supports Tables = " + bc.Tables + "<br>";
			outputStr += spaceStr + "Supports Cookies = " + bc.Cookies + "<br>";
			outputStr += spaceStr + "Supports VB Script = " + bc.VBScript + "<br>";
			outputStr += spaceStr + "Supports JavaScript = " + bc.JavaScript + "<br>";
			outputStr += spaceStr + "Supports Java Applets = " + bc.JavaApplets + "<br>";
			outputStr += spaceStr + "Supports ActiveX Controls = " + bc.ActiveXControls + "<br>";
			outputStr += spaceStr + "CDF = " + bc.CDF + "<br>";

			outputStr += "<br>";
			outputStr += "UserAgent : " + Request.UserAgent + "<br>";

			outputStr += "UserHostAddress : " + Request.UserHostAddress + "<br>";

			outputStr += "UserHostName : " + Request.UserHostName + "<br>";

			outputStr += "<br>";
			outputStr += "UserLanguages : <br>";
			foreach (string language in  Request.UserLanguages)
				outputStr += spaceStr + language + "<br>";

			Response.Write(outputStr);

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
