using System;
using System.Web;

namespace Chapter08.Ex03
{
	public class Chap08_Ex03 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.TextBox TextBox1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				Response.Cookies["TestCookie1"].Value = "TestCookie1Value";
				Response.Cookies["TestCookie2"].Value = "TestCookie2Value";
				Response.Cookies["TextBox1"].Value = "Cookie";
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void Button1_Click(object sender, System.EventArgs e)
		{
			string outputStr = String.Empty;
			string spaceStr = "&nbsp;&nbsp;&nbsp;&nbsp;";

			outputStr += "QueryString :<br>";
			foreach (string key in Request.QueryString.Keys)
				outputStr += spaceStr + key + " : " + Request.QueryString[key] + "<br>";

			outputStr += "<br>";
			outputStr += "Form :<br>";
			foreach (string key in Request.Form.Keys)
				outputStr += spaceStr + key + " : " + Request.Form[key] + "<br>";

			outputStr += "<br>";
			outputStr += "Cookies :<br>";
			foreach (string key in Request.Cookies.Keys)
				outputStr += spaceStr + key + " : " + Request.Cookies[key].Value + "<br>";

			outputStr += "<br>";
			outputStr += "ServerVariables :<br>";
			foreach (string key in Request.ServerVariables.Keys)
				outputStr += spaceStr + key + " : " + Request.ServerVariables[key] + "<br>";

			outputStr += "<br>";
			outputStr += "Params :<br>";
			foreach (string key in Request.Params.Keys)
				outputStr += spaceStr + key + " : " + Request.Params[key] + "<br>";

			Label1.Text = outputStr; 
		}
	}
}
