using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.Web.UI.WebControls;
using System.Configuration;
using System.Web.Caching;

namespace Chapter10.Ex07
{
	public class Chapter10_Ex07 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			DataSet ds = null;

			if (Cache["tbADO_TUT_3_PARENT"] == null)
			{
				SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["SqlConnectionString"]);
				SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_PARENT", conn);

				ds = new DataSet();
				da.Fill(ds, "Parent");

				CacheDependency dep = new CacheDependency(@"C:\tbADO_TUT_3_PARENT_Changed.txt");
				Cache.Insert("tbADO_TUT_3_PARENT", ds, dep, System.Web.Caching.Cache.NoAbsoluteExpiration, TimeSpan.FromMinutes(30));

				Response.Write("  DataSet !<br>");
			}
			else
			{
				ds = (DataSet)Cache["tbADO_TUT_3_PARENT"];
				Response.Write("Cache  DataSet !<br>");
			}

			DataGrid1.DataSource = ds.Tables[0].DefaultView;
			DataGrid1.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
