using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Configuration;

namespace Chapter17
{
	/// <summary>
	/// WebForm1   Դϴ.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["SqlConnectionString"]);
			SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_PARENT", conn);
			SqlCommandBuilder cmdBuilder = new SqlCommandBuilder(da);
			SqlCommand cmd;

			cmd = cmdBuilder.GetInsertCommand();
			Response.Write("<h3>InsertCommand</h3>");
			DisplayCommandDetail(cmd);

			cmd = cmdBuilder.GetUpdateCommand();
			Response.Write("<h3>UpdateCommand</h3>");
			DisplayCommandDetail(cmd);

			cmd = cmdBuilder.GetDeleteCommand();
			Response.Write("<h3>DeleteCommand</h3>");
			DisplayCommandDetail(cmd);
		}

		void DisplayCommandDetail(SqlCommand cmd)
		{
			string nbsp = "&nbsp;&nbsp;&nbsp;&nbsp;";

			Response.Write("CommandText : " + cmd.CommandText + "<br>");
			Response.Write("CommandType : " + cmd.CommandType + "<br>");
			Response.Write("Parameters : <br>");
			foreach(SqlParameter parm in cmd.Parameters)
			{
				Response.Write(nbsp + "ParameterName : " + parm.ParameterName + "<br>");
				Response.Write(nbsp + "SourceColumn : " + parm.SourceColumn + "<br>");
				Response.Write(nbsp + "DbType : " + parm.DbType + "<br>");
			}
			Response.Write("<br>");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
