using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter20.Ex05
{
	public class Chap19_Ex05 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				BindData(null);
			}
		}

		private void BindData(string sortExpr)
		{
			DataView dv = GetData();
			if(sortExpr != null)
				dv.Sort = GetSortExpr(sortExpr);

			DataGrid1.DataSource = dv;
			DataGrid1.DataBind();
		}

		public DataView GetData()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation2";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlDataAdapter da = new SqlDataAdapter(strQuery, sqlConn);

			DataSet ds = new DataSet();
			da.Fill(ds, "DataPresentation2");
			return ds.Tables["DataPresentation2"].DefaultView;
		}

		// ̳  ٲٴ ǥ ڿ 
		private string GetSortExpr(string sortField)
		{
			//Attributes Ӽ   ´.
			//      ̴.
			string _sortField = DataGrid1.Attributes["SortField"];
			string _sortDirection = DataGrid1.Attributes[sortField+"Direction"];
			//   ʵ sortField  
			if (_sortField == sortField)
			{
				//  ٲش.
				if (_sortDirection == "asc")
					_sortDirection = "desc";
				else
					_sortDirection = "asc";
			}
			else
			{
				_sortDirection = "asc";
			}

			// Ľ ˻     ֵ
			//Attributes Ӽ ̿ Ѵ.
			//   Ʈϴ  ȴ.
			//Attributes Ӽ ViewState   ִ.
			DataGrid1.Attributes["SortField"] = sortField;
			DataGrid1.Attributes[sortField+"Direction"] = _sortDirection;

			return sortField + " " + _sortDirection;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DataGrid1.SortCommand += new System.Web.UI.WebControls.DataGridSortCommandEventHandler(this.DataGrid1_SortCommand);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void DataGrid1_SortCommand(object source, System.Web.UI.WebControls.DataGridSortCommandEventArgs e)
		{
			BindData(e.SortExpression);
		}
	}
}
