using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CustomControls.Ex07
{
	public class Ex07_Control : WebControl
	{
		public Ex07_Control() : base(HtmlTextWriterTag.Span) {}

		protected override void RenderContents(HtmlTextWriter writer)
		{
			base.RenderContents(writer);
			writer.Write("[ ڿ]");
			writer.WriteLine();
		}

		public override void RenderBeginTag(System.Web.UI.HtmlTextWriter writer)
		{
			writer.Write("[ ± ]");
			base.RenderBeginTag(writer);
			writer.Write("[ ± ]");
			writer.WriteLine();
		}

		public override void RenderEndTag(System.Web.UI.HtmlTextWriter writer)
		{
			writer.Write("[ݴ ± ]");
			base.RenderEndTag(writer);
			writer.Write("[ݴ ± ]");
			writer.WriteLine();
		}

		protected override void Render(HtmlTextWriter writer)
		{
			writer.Write("[ ]");
			writer.WriteLine();
			base.Render(writer);
			writer.Write("[ ]");
		}
	}
}
