using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Label
{
	/// <summary>
	/// SimpleLabel   Դϴ.
	/// </summary>
	[DefaultProperty("Text"), 
		ToolboxData("<{0}:SimpleLabel runat=server></{0}:SimpleLabel>")]
	public class SimpleLabel : System.Web.UI.WebControls.WebControl
	{
		[Bindable(true), 
			Category("Appearance"), 
			DefaultValue("")] 
		public string Text 
		{
			get
			{
				object o = ViewState["text"];
				return((o == null) ? String.Empty : (string)o);
			}

			set
			{
				ViewState["text"] = value;
			}
		}

		/// <summary> 
		///  Ʈ   Ű  մϴ.
		/// </summary>
		/// <param name="output">   HTML ۼ </param>
		protected override void Render(HtmlTextWriter output)
		{
			/*
			output.AddStyleAttribute(HtmlTextWriterStyle.BackgroundColor,"blue");
			output.AddAttribute(HtmlTextWriterAttribute.Alt,"Attribute Test");
			//AddStyleAttribute AddAttribute ޼ҵ
			//RenderBeginTag ޼ҵ庸  ȣǾ Ѵ.
			output.RenderBeginTag(HtmlTextWriterTag.Span);
			output.Write(Text);
			output.RenderEndTag();
			*/
			base.Render(output);
		}

		protected override void RenderContents(System.Web.UI.HtmlTextWriter writer)
		{
			writer.Write(Text);
			base.RenderContents(writer);
		}

	}
}
