using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Start
{
	[DefaultProperty("Text"), 
		ToolboxData("<{0}:HelloWebControl runat=server></{0}:HelloWebControl>")]
	public class HelloWebControl : System.Web.UI.WebControls.WebControl
	{
		private string text;
	
		[Bindable(true), 
			Category("Appearance"), 
			DefaultValue("")] 
		public string Text 
		{
			get
			{
				return text;
			}

			set
			{
				text = value;
			}
		}

		// : base(...)  ȣ  ⺻
		// HtmlTextWriterTag.Span ȴ.
		//public HelloWebControl() : base(HtmlTextWriterTag.Div)
		//{
		//}

		protected override void Render(HtmlTextWriter output)
		{
			// ȣ RenderBeginTag, AddAttributesToRender, 
			//RenderContents, RenderEndTag ʷ ȣѴ.
			base.Render(output);
			//output.Write(Text);
		}

		// ޼ҵ WebControl Render ȣȴ.
		//׷Ƿ  ޼ҵ尡 ȣǰ Ϸ Render ޼ҵ忡
		//base.Render(output);  ־ Ѵ.
		protected override void RenderContents(System.Web.UI.HtmlTextWriter writer)
		{
			// ޼ҵ忡 writer ̿ ϴ 
			//± ȿ µȴ.
			//writer.Write(Text);
			
			//writer.Write("RenderContents");
			base.RenderContents(writer);
		}

		//AddAttribute AddStyleAttribute ȣϰ ȴ.
		protected override void AddAttributesToRender(System.Web.UI.HtmlTextWriter writer)
		{
			//writer.AddAttribute(HtmlTextWriterAttribute.Onclick,"alert('OK')");
			
			//writer.Write("AddAttributesToRender");
			base.AddAttributesToRender(writer);
		}

		//
		public override void RenderBeginTag(System.Web.UI.HtmlTextWriter writer)
		{
			//writer.Write("RenderBeginTag");
			base.RenderBeginTag(writer);
		}

		public override void RenderEndTag(System.Web.UI.HtmlTextWriter writer)
		{
			//writer.Write("RenderEndTag");
			base.RenderEndTag(writer);
		}
	}
}
