using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.PracticalControls
{
/*
//  Ʈ Ϸ
// WebUIValidation.js  Page_ClientValidate Լ
// ó Ѵ.
function Page_ClientValidate() {
	var i;
	for (i = 0; i < Page_Validators.length; i++) {
		ValidatorValidate(Page_Validators[i]);
	}
	ValidatorUpdateIsValid();    
	ValidationSummaryOnSubmit();

	//̺κ ߰
	if (typeof(MyValidationSummaryOnSubmit) == "function") 
		MyValidationSummaryOnSubmit();
	
	Page_BlockSubmit = !Page_IsValid;
	return Page_IsValid;
}
*/

	[ToolboxData("<{0}:MyValidationSummry runat=server></{0}:MyValidationSummry>")]
	public class MyValidationSummry : System.Web.UI.WebControls.WebControl
	{
		private bool isRuntime = false;
		private string MyValidationSummryScript = @"
<script language=""javascript"">
<!--
function MyValidationSummaryOnSubmit() {
    var i;
    for (i = 0; i < Page_Validators.length; i++) {
        if (!Page_Validators[i].isvalid) {
			//޼ ڽ
            alert(Page_Validators[i].errormessage);
			//ش Ʈѷ Է Ŀ ش
			if (typeof(Page_Validators[i].controltovalidate) != ""undefined"") 
				document.getElementById(Page_Validators[i].controltovalidate).focus();

            return;
        }
   }
}
//-->
</script>
		";

		protected virtual bool DetermineRenderUplevel()
		{
			Page page = Page;
			if (page == null || page.Request == null) {
				return false;
			}

			return (page.Request.Browser.W3CDomVersion.Major >= 1
				&& page.Request.Browser.EcmaScriptVersion.CompareTo(new Version(1, 2)) >= 0);
		}

		protected override void OnPreRender(EventArgs e)
		{
			base.OnPreRender(e);

			isRuntime = true;
			if (DetermineRenderUplevel()) {
				if (!Page.IsClientScriptBlockRegistered("MyValidationSummryScript"))
					Page.RegisterClientScriptBlock("MyValidationSummryScript", MyValidationSummryScript);
			}
		}

		protected override void Render(HtmlTextWriter writer)
		{
			if (!isRuntime)
				writer.Write(this.ID);
		}
	}
}
