using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Validators
{
	[ToolboxData("<{0}:SimpleRequiredFieldValidator1 runat=server ErrorMessage=\"SimpleRequiredFieldValidator1\"></{0}:SimpleRequiredFieldValidator1>")]
	public class SimpleRequiredFieldValidator1 : SimpleBaseValidator1
	{
		[Category("Behavior"),
		DefaultValue("")]                                         
		public string InitialValue {
			get { 
				object o = ViewState["InitialValue"];
				return((o == null) ? String.Empty : (string)o);
			}
			set {ViewState["InitialValue"] = value;}
		}

		protected override bool EvaluateIsValid() 
		{
			string controlValue = GetControlValidationValue(ControlToValidate);
			if (controlValue == null)
				throw new Exception("ControlToValidate  Ʈѿ ȿ ˻縦   ϴ.");

			return(!controlValue.Trim().Equals(InitialValue.Trim()));
		} 
	}
}
