using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter22.Ex04
{
	public class Chap22_Ex04 : System.Web.UI.Page
	{
		protected CustomControls.DropDownList.DropDownListEasily DropDownListEasily1;
		protected CustomControls.DropDownList.DropDownListFully DropDownListFully1;
		protected CustomControls.Button.SimpleButton Simplebutton1;
		protected CustomControls.Label.SimpleLabel SimpleLabel1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				DropDownListEasily1.DataSource = MakeDataSource();
				DropDownListEasily1.DataBind();

				SqlConnection cnn = new SqlConnection(ConfigurationSettings.AppSettings["NWDConStr"]);
				SqlCommand cmd = new SqlCommand("Select * from Categories",cnn);
				SqlDataReader dr;
    
				cnn.Open();
				dr=cmd.ExecuteReader();
		    
				DropDownListFully1.DataSource = dr;
				DropDownListFully1.DataTextField = "CategoryName";
				DropDownListFully1.DataValueField = "CategoryID";
				DropDownListFully1.DataBind();

				dr.Close();
				cnn.Close();
			}
		}

		private ArrayList MakeDataSource()
		{
			ArrayList arr = new ArrayList();

			for (int i=1; i<5; i++)	{
				arr.Add(i);
			}

			return arr;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DropDownListEasily1.SelectedIndexChanged += new System.EventHandler(this.DropDownListEasily1_SelectedIndexChanged);
			this.DropDownListFully1.SelectedIndexChanged += new System.EventHandler(this.DropDownListFully1_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void DropDownListFully1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string nbsp = "&nbsp;&nbsp;&nbsp;&nbsp;";
			SimpleLabel1.Text = "DropDownListFully1 : <br>" + 
				nbsp + "SelectedItem.Text=" + DropDownListFully1.SelectedItem.Text + "<br>" + 
				nbsp + "SelectedItem.Value=" + DropDownListFully1.SelectedItem.Value + "<br>";
		}

		private void DropDownListEasily1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string nbsp = "&nbsp;&nbsp;&nbsp;&nbsp;";
			SimpleLabel1.Text = "DropDownListEasily1 : <br>" + 
				nbsp + "SelectedItem.Text=" + DropDownListEasily1.SelectedItem.Text + "<br>" + 
				nbsp + "SelectedItem.Value=" + DropDownListEasily1.SelectedItem.Value + "<br>";
		}
	}
}
