IF EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name = N'AspDotNetBook')
	DROP DATABASE [AspDotNetBook]
GO

CREATE DATABASE [AspDotNetBook]  ON (NAME = N'AspDotNetBook_Data', FILENAME = N'D:\Program Files\Microsoft SQL Server\MSSQL\data\AspDotNetBook_Data.MDF' , SIZE = 2, FILEGROWTH = 10%) LOG ON (NAME = N'AspDotNetBook_Log', FILENAME = N'D:\Program Files\Microsoft SQL Server\MSSQL\data\AspDotNetBook_Log.LDF' , SIZE = 1, FILEGROWTH = 10%)
 COLLATE Korean_Wansung_CI_AS
GO

exec sp_dboption N'AspDotNetBook', N'autoclose', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'bulkcopy', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'trunc. log', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'torn page detection', N'true'
GO

exec sp_dboption N'AspDotNetBook', N'read only', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'dbo use', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'single', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'autoshrink', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'ANSI null default', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'recursive triggers', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'ANSI nulls', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'concat null yields null', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'cursor close on commit', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'default to local cursor', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'quoted identifier', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'ANSI warnings', N'false'
GO

exec sp_dboption N'AspDotNetBook', N'auto create statistics', N'true'
GO

exec sp_dboption N'AspDotNetBook', N'auto update statistics', N'true'
GO

use [AspDotNetBook]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tbADO_TUT_3_CHILD_tbADO_TUT_3_PARENT]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tbADO_TUT_3_CHILD] DROP CONSTRAINT FK_tbADO_TUT_3_CHILD_tbADO_TUT_3_PARENT
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tbDataPresentation2_Orders_tbDataPresentation2]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tbDataPresentation2_Orders] DROP CONSTRAINT FK_tbDataPresentation2_Orders_tbDataPresentation2
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbADO_TUT_3_CHILD]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbADO_TUT_3_CHILD]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbDataPresentation2_Orders]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbDataPresentation2_Orders]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbADO_TUT_1]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbADO_TUT_1]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbADO_TUT_2]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbADO_TUT_2]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbADO_TUT_3_PARENT]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbADO_TUT_3_PARENT]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbBLOB]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbBLOB]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbDailyPlan]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbDailyPlan]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbDataPresentation1]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbDataPresentation1]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbDataPresentation1_Selected]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbDataPresentation1_Selected]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbDataPresentation2]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbDataPresentation2]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbMemo]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbMemo]
GO

CREATE TABLE [dbo].[tbADO_TUT_1] (
	[integerType] [int] NULL ,
	[stringType] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[datetimeType] [datetime] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbADO_TUT_2] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[integerType] [int] NULL ,
	[stringType] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbADO_TUT_3_PARENT] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[stringValue] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[dateTimeValue] [datetime] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbBLOB] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[name] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[size] [bigint] NULL ,
	[type] [varchar] (30) COLLATE Korean_Wansung_CI_AS NULL ,
	[image] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbDailyPlan] (
	[rtDate] [smalldatetime] NOT NULL ,
	[rtNote] [text] COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbDataPresentation1] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[item] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[price] [money] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbDataPresentation1_Selected] (
	[controlName] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[itemId] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbDataPresentation2] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[title] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[author] [varchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[price] [money] NOT NULL ,
	[page] [int] NOT NULL ,
	[publishDate] [datetime] NOT NULL ,
	[description] [text] COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbMemo] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[regDate] [smalldatetime] NOT NULL ,
	[memo] [varchar] (100) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbADO_TUT_3_CHILD] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[parentId] [int] NOT NULL ,
	[stringValue] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbDataPresentation2_Orders] (
	[id] [int] IDENTITY (1, 1) NOT NULL ,
	[prodId] [int] NOT NULL ,
	[purchaseName] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[purchaseCount] [int] NOT NULL ,
	[priceTotal] [money] NOT NULL ,
	[purchaseDate] [datetime] NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[tbADO_TUT_2] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbADO_TUT_2] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tbADO_TUT_3_PARENT] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbADO_TUT_3_PARENT] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tbBLOB] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbBLOB] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tbDataPresentation1] WITH NOCHECK ADD 
	CONSTRAINT [PK_DataPresentation1] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tbDataPresentation2] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbDataPresentation2] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tbMemo] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbMemo] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tbADO_TUT_3_CHILD] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbADO_TUT_3_CHILD] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tbDataPresentation2_Orders] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbDataPresentation2_Orders] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tbADO_TUT_2] WITH NOCHECK ADD 
	CONSTRAINT [IX_tbADO_TUT_2] UNIQUE  NONCLUSTERED 
	(
		[integerType]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tbADO_TUT_3_PARENT] WITH NOCHECK ADD 
	CONSTRAINT [DF_tbADO_TUT_3_PARENT_dateTimeValue] DEFAULT (getdate()) FOR [dateTimeValue]
GO

ALTER TABLE [dbo].[tbDailyPlan] WITH NOCHECK ADD 
	CONSTRAINT [PK_tbDailyPlan] PRIMARY KEY  NONCLUSTERED 
	(
		[rtDate]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tbDataPresentation2] WITH NOCHECK ADD 
	CONSTRAINT [DF_tbDataPresentation2_publishDate] DEFAULT (getdate()) FOR [publishDate]
GO

ALTER TABLE [dbo].[tbMemo] WITH NOCHECK ADD 
	CONSTRAINT [DF_tbMemo_regDate] DEFAULT (getdate()) FOR [regDate]
GO

 CREATE  INDEX [IX_tbADO_TUT_3_CHILD] ON [dbo].[tbADO_TUT_3_CHILD]([parentId]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[tbDataPresentation2_Orders] WITH NOCHECK ADD 
	CONSTRAINT [DF_tbDataPresentation2_Orders_purchaseDate] DEFAULT (getdate()) FOR [purchaseDate]
GO

ALTER TABLE [dbo].[tbADO_TUT_3_CHILD] ADD 
	CONSTRAINT [FK_tbADO_TUT_3_CHILD_tbADO_TUT_3_PARENT] FOREIGN KEY 
	(
		[parentId]
	) REFERENCES [dbo].[tbADO_TUT_3_PARENT] (
		[id]
	)
GO

ALTER TABLE [dbo].[tbDataPresentation2_Orders] ADD 
	CONSTRAINT [FK_tbDataPresentation2_Orders_tbDataPresentation2] FOREIGN KEY 
	(
		[prodId]
	) REFERENCES [dbo].[tbDataPresentation2] (
		[id]
	)
GO

