using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace HowTo
{
	public class EventFiringOrder : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button Button1;
	
		public EventFiringOrder()
		{
			Page.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Init(object sender, EventArgs e)
		{
			Response.Write ( "Page_Init Fired.<br>" );
			InitializeComponent();
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			Response.Write ( "Page_Load Fired.<br>" );
			if ( !Page.IsPostBack )
			{
				Session["MyValue"] = "The Page_Load Event Was Fired!<br>";
				DoSessionStuffHere();
			}
		}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			Response.Write ( "Page_PreRender Fired.<br>" );
		}

		private void DoSessionStuffHere()
		{
			Response.Write ( "DoSessionStuffHere Fired.<br>" );
			Response.Write ( "Session Value = " );
			Response.Write ( Session["MyValue"] );
		}

		private void Button1_Click(object sender, System.EventArgs e)
		{
			Response.Write ( "Button1_Click Fired.<br>" );
			Session["MyValue"] = "The Button1_Click Event Was Fired!<br>";
			DoSessionStuffHere();
		}

		#region Web Form Designer generated code
		private void InitializeComponent()
		{    
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion
	}
}
