using System;
using System.IO;
using System.Web;
using System.Web.Caching;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace PowerOfDotNet.WebMail
{
	public class DownloadMailAttach : IHttpHandler
	{
		public void ProcessRequest(HttpContext context)
		{
			string strFileName = context.Request.QueryString["file"].ToString();
			string strSavedFileName = context.Request.QueryString["savedFile"].ToString();
			string userId = context.User.Identity.Name;
			string userDir = context.Request.Cookies["usersInfo"]["UserDir"].ToString();

			//ٿε   ͸ Ѵ.
			string filePath = context.Request.MapPath("/User/UserDir/" + userDir 
				+ "/" + userId + "/mail_file/" + strSavedFileName);
			FileInfo fi = new FileInfo(filePath);

			context.Response.AddHeader("Content-Disposition","attachment;filename="+ context.Server.UrlEncode(strFileName) );
			context.Response.ContentType = "application/unknown";
			context.Response.WriteFile(filePath, 0, fi.Length);
			context.Response.End();
		}

		public bool IsReusable
		{
			get { return true; }
		}
	}
}