namespace PowerOfDotNet.Home
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web.Security;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		LoginBox   Դϴ.
	/// </summary>
	public abstract class LoginBox : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.PlaceHolder NotLoginedHolder;
		protected System.Web.UI.WebControls.PlaceHolder LoginedHolder;
		protected MyWebLibs.ServerControls.RollOverImageButton rolingbtnLogin;
		protected System.Web.UI.HtmlControls.HtmlInputText txtLoginID1;
		protected System.Web.UI.HtmlControls.HtmlInputText txtLoginPassword1;
		protected MyWebLibs.ServerControls.RollOverImageButton rolingbtnLogout;
		protected System.Web.UI.HtmlControls.HtmlInputText txtLoginID2;
		protected System.Web.UI.HtmlControls.HtmlInputText txtLoginPassword2;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;

		protected string _userDir = String.Empty;
		protected MyWebLibs.ServerControls.RollOverImageButton RollOverImageButton1;
		protected MyWebLibs.ServerControls.RollOverHyperLink rolhypJoining;

		private bool _isAuthenticated;
		
		private void Page_Load(object sender, System.EventArgs e)
		{
			_isAuthenticated = Request.IsAuthenticated;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.rolingbtnLogin.Click += new System.Web.UI.ImageClickEventHandler(this.rolingbtnLogin_Click);
			this.rolingbtnLogout.Click += new System.Web.UI.ImageClickEventHandler(this.rolingbtnLogout_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.LoginBox_PreRender);

		}
		#endregion

		void rolingbtnLogin_Click(object sender, ImageClickEventArgs e) 
		{
			if (!Page.IsValid)
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ID йȣ Ȯ ϼž մϴ.");

			// Attempt to Validate User Credentials using UsersDB
			UsersDB user = new UsersDB();
			String userName = user.Login(txtLoginID1.Value, txtLoginPassword1.Value);

			if ((userName != null) && (userName != "")) 
			{
				// Use security system to set the UserID within a client-side Cookie
				//FormsAuthentication.SetAuthCookie(txtLoginID1.Value, false);
				SqlDataReader dr = user.GetSingleUser(txtLoginID1.Value);
				dr.Read();
				string dbUserName = dr["Name"].ToString();
				string dbUserDir = dr["UserDirectory"].ToString();
				dbUserDir = this.MapPath("/User/UserDir/" + dbUserDir + "/" + txtLoginID1.Value);
				PowerOfDotNet.Components.PortalUtil.MakeWelcomeImage(dbUserName, dbUserDir);
				FormsAuthentication.RedirectFromLoginPage(txtLoginID1.Value, false);
			}
			else 
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ԷϽ ID йȣ  Ƚϴ.");
			}
			//_isAuthenticated = true;
		}

		private void rolingbtnLogout_Click(object sender, ImageClickEventArgs e) 
		{
			FormsAuthentication.SignOut();
			// Invalidate roles token
			Response.Cookies["portalroles"].Value = null;
			Response.Cookies["portalroles"].Expires = new System.DateTime(2000, 1, 1);
			Response.Cookies["portalroles"].Path = "/";

			Response.Cookies["usersInfo"].Value = "";
			Response.Cookies["usersInfo"].Expires = new System.DateTime(2000, 1, 1);
			Response.Cookies["usersInfo"].Path = "/";

			//_isAuthenticated = false;
			Response.Redirect(Request.RawUrl);
		}

		private void LoginBox_PreRender(object sender, System.EventArgs e)
		{
			//Request.IsAuthenticated ̹  ȣ ģ ĺ ݿ Ǳ⶧
			//̷    ˻縦 Ѵ.
			NotLoginedHolder.Visible = !_isAuthenticated;
			LoginedHolder.Visible = _isAuthenticated;
			if (!_isAuthenticated)
				MyWebLibs.Utilities.CommonMethods.SetFocus(txtLoginID1);
			else
			{
				_userDir = "/User/UserDir/" + Request.Cookies["usersInfo"]["UserDir"] +
								"/" + this.Page.User.Identity.Name;
			}
			this.DataBind();
		}
	}
}
