/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.MyPage
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	public abstract class DailyPlanCalendar : System.Web.UI.UserControl
	{
		protected System.Web.UI.HtmlControls.HtmlInputHidden hiddenCurentPageIdentity;

		private DateTime[] rtDate = new DateTime[43]; //31 + (6 * 2) = 43
		private string[] rtNote = new string[43];
		protected System.Web.UI.WebControls.Calendar calDailyPlan;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack) {
				//DBó    ʱȭ
				calDailyPlan.VisibleDate = DateTime.Today;
			}
		}

		//DB    迭 Ѵ.
		private void LoadMonthData(string userId, DateTime dtDate)
		{
			PowerOfDotNet.Components.MyPageDB oDB = new PowerOfDotNet.Components.MyPageDB();
			SqlDataReader drList = oDB.ReadMonthList(userId, dtDate);
			int intIndex = 0;

			//迭 ʱȭ
			rtDate.Initialize();
			rtNote.Initialize();
			while (drList.Read())
			{
				rtDate[intIndex] = drList.GetDateTime(1);
				if (drList.IsDBNull(2)) rtNote[intIndex] = null;
				else rtNote[intIndex] = drList.GetString(2);
				intIndex++;
			}
			drList.Close();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.calDailyPlan.DayRender += new System.Web.UI.WebControls.DayRenderEventHandler(this.calDailyPlan_DayRender);
			this.calDailyPlan.PreRender += new System.EventHandler(this.calDailyPlan_PreRender);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void calDailyPlan_DayRender(object sender, System.Web.UI.WebControls.DayRenderEventArgs e)
		{
			//LoadMonthData ޼ҵ ä 迭 
			// ϴ ¥ ִ ˻
			int intIndex = Array.IndexOf(rtDate, e.Day.Date);
			string Note = "";

			//ϴ ¥  
			if (intIndex != -1)
			{
				if (rtNote[intIndex] != null)  
					Note = e.Day.Date.ToString("yyyy-MM-dd") + 
						"<br><br>" + rtNote[intIndex].Replace("\n","<br>");
			}
			else
			{
				Note = " ";
			}

			//e.Cell.Controls  0° ִ  յڷ Ѵ.
			string strDiv = "<div id=\"disp_div_" + e.Day.Date.ToString("MMdd") + 
					"\" style=\"width:100%; height:100%;\" onmouseover=\"javascript:makeCursorHand(this);showHide('" + 
					e.Day.Date.ToString("MMdd") + "')\" onmouseout=\"javascript:showHide(0)\">";
			e.Cell.Controls.AddAt(0, new LiteralControl(strDiv));
			strDiv = "</div><div id=\"hidden_div_" + e.Day.Date.ToString("MMdd") + 
					"\" style=\"display:none\">" + Note + "</div>";
			e.Cell.Controls.Add(new LiteralControl(strDiv));

			if (Note != " ")
			{
				//    ٲش.
				e.Cell.CssClass = "planExist";
			}

			//¥ Ŭϸ    ִ 
			//ڽ 찡 
			e.Cell.Attributes["onclick"] = "OpenDailyPlanInut('" + 
				e.Day.Date.ToString("yyyy-MM-dd") + "');return false;";
		}

		private void calDailyPlan_PreRender(object sender, System.EventArgs e)
		{
			LoadMonthData(this.Page.User.Identity.Name, calDailyPlan.VisibleDate);

			//  Ŭ̾Ʈ ڽ â θâ ĺϱ   δ.
			hiddenCurentPageIdentity.Value = calDailyPlan.VisibleDate.ToString("yyyy-MM");

			string myPageMailHiddenValueSetup = @"
<script language=javascript>
<!--
		hiddenIdentity = document.getElementById(""{0}"");
//-->
</script>
			";
			myPageMailHiddenValueSetup = String.Format(myPageMailHiddenValueSetup, 
				hiddenCurentPageIdentity.ClientID);
			Page.RegisterStartupScript("_myPageMailHiddenValueSetup", myPageMailHiddenValueSetup);
		}
	}
}
