/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.NewStudy.Lacture
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using MyWebLibs.Utilities;

	/// <summary>
	///		Write   Դϴ.
	/// </summary>
	public abstract class Write : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.TextBox txtSubject;
		protected System.Web.UI.WebControls.TextBox txtContent;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnFormat;
		protected System.Web.UI.HtmlControls.HtmlInputFile File2;
		protected System.Web.UI.HtmlControls.HtmlInputFile File3;
		protected System.Web.UI.HtmlControls.HtmlInputFile File4;
		protected System.Web.UI.HtmlControls.HtmlInputFile File5;
		protected System.Web.UI.HtmlControls.HtmlInputFile File6;
		protected System.Web.UI.HtmlControls.HtmlInputFile File7;
		protected System.Web.UI.HtmlControls.HtmlInputFile File8;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWrite;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.HtmlControls.HtmlInputFile File1;
		protected System.Web.UI.WebControls.Panel pnlHeader;
		protected System.Web.UI.WebControls.CheckBox chkboxUseAvatar;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstAvatarExp;

		private PowerOfDotNet.Components.BoardLactureInfo _blInfo;


		private void Page_Load(object sender, System.EventArgs e)
		{
			//UriĶŸ   ´.
			int boardId = CommonMethods.RequestInt(Request.Params["TableId"], -1);

			//߱Ⱓ  ̷ Ѵ.
			//this.RemoveObjectCache("BoardLactureTableInfo" + boardId);
			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardLactureInfo)this.GetObjectFromCache("BoardLactureTableInfo" + boardId);
			if (_blInfo == null) {
				PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardLactureTableInfo" + boardId, _blInfo, 30);
			}

			if (!IsPostBack) {
				//GET Ķ͸  ۼ 
				//Ǹ  ڸ ´.
				bool authority;
				if (PortalSecurity.IsInRoles(_blInfo.BBSRoles))	authority = true;
				else if (_blInfo.BBSType == 0)	authority = true;
				else	authority = false;
				// Խ̸ Ϲ ڴ   Ѵ.
				if (!authority) MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ڸ   ֽϴ.");

				this.Form.Enctype = "multipart/form-data";

				PowerOfDotNet.Components.AvatarDB dbAvatar = new PowerOfDotNet.Components.AvatarDB();
				SqlDataReader drAvatarExp = dbAvatar.GetAvatarExpression();
				rdobtnlstAvatarExp.DataSource = drAvatarExp;
				rdobtnlstAvatarExp.DataTextField = "Description";
				rdobtnlstAvatarExp.DataValueField = "ID";
				rdobtnlstAvatarExp.DataBind();
				rdobtnlstAvatarExp.SelectedIndex = 0;
			}
			MyWebLibs.Utilities.CommonMethods.SetFocus(txtSubject);

			pnlHeader.Style["text-align"] = "center";
			//ŸƲ 
			switch (_blInfo.BBSDisplayType)
			{
				case 0 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSSubject));
					pnlHeader.Style["font-size"] = "16px";
					pnlHeader.Style["font-weight"] = "bold";
					break;
				case 1 :
					pnlHeader.Controls.Add(new LiteralControl("<img src='" + _blInfo.BBSImage + "' />"));
					break;
				case 2 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSHtml));
					break;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnWrite.ServerClick += new System.EventHandler(this.btnWrite_ServerClick);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnWrite_ServerClick(object sender, System.EventArgs e)
		{
			if (Page.IsValid)
			{
				PowerOfDotNet.Components.BoardLactureData oData = new PowerOfDotNet.Components.BoardLactureData();
			
				if (Request.IsAuthenticated)
				{
					UsersDB dbUser = new UsersDB();
					SqlDataReader dr = dbUser.GetSingleUser(this.Page.User.Identity.Name);
					dr.Read();

					oData.UserID = this.Page.User.Identity.Name;
					oData.Writer = dr["Name"].ToString();
					oData.Email = dr["Email"].ToString();
					oData.UseAvatar = chkboxUseAvatar.Checked;
					oData.AvatarExpression = Convert.ToByte(rdobtnlstAvatarExp.SelectedItem.Value);
					dr.Close();
				}
				else
				{
					oData.UserID = "";
					oData.Writer = "";
					oData.Email = "";
					oData.UseAvatar = false;
					oData.AvatarExpression = 0;
				}
				oData.Subject = txtSubject.Text;
				oData.Format = Convert.ToByte(rdobtnFormat.SelectedItem.Value);
				oData.Content = txtContent.Text;
				oData.Password = "";
				oData.UserIP = Request.ServerVariables["REMOTE_ADDR"];


				HttpFileCollection UploadFiles = Request.Files;
				PowerOfDotNet.Components.BoardLactureDB oDB = new PowerOfDotNet.Components.BoardLactureDB();
				oDB.AddNew(_blInfo.BBSTable, oData, UploadFiles); 

				Response.Redirect(GetLink(_blInfo.BBSPageNameList));
			}
		}
	}
}
