Imports System.Data.SqlClient

Public Class Form1
    Inherits System.Windows.Forms.Form
    Const SQL_CONNECTION = "Data Source=localhost;Initial Catalog=Northwind;" & _
        "User ID=sa;"
    Const SQL_CUSTOMERS = "SELECT * FROM customers"

    Public Function ListCustomersInDataSet() As System.Data.DataSet

        ' Purpose:  Return the Supplier Countries, in a DataSet

        Dim sqlConn As SqlConnection
        Dim sqlCmd As SqlCommand
        Dim sqlAdapt As SqlDataAdapter
        Dim rowDataSet As New DataSet("ListOfCustomers")

        Try
            ' Create a new connection object
            sqlConn = New SqlConnection(SQL_CONNECTION)

            ' Create a new command object
            sqlCmd = New SqlCommand(SQL_CUSTOMERS, sqlConn)

            ' Open the connection
            sqlConn.Open()

            ' Open a DataAdapter object, using the command object
            sqlAdapt = New SqlDataAdapter(sqlCmd)

            ' Execute the command and retrieve the records in the DataSet
            ' The DataTable is named "Customers"
            sqlAdapt.Fill(rowDataSet, "Customers")

        Catch e As SqlException
            MsgBox("Error " & e.Number & ": " & e.Message & " [" & _
               e.Source & "]")
        Finally
            sqlConn.Close() ' The connection is not needed anymore
        End Try

        Return (rowDataSet)

    End Function

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid
    Friend WithEvents Button1 As System.Windows.Forms.Button
    
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.DataGrid1 = New System.Windows.Forms.DataGrid()
        Me.btnMerge = New System.Windows.Forms.Button()
        Me.Button1 = New System.Windows.Forms.Button()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'DataGrid1
        '
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.Location = New System.Drawing.Point(8, 8)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.Size = New System.Drawing.Size(760, 408)
        Me.DataGrid1.TabIndex = 0
        '
        'btnMerge
        '
        Me.btnMerge.Location = New System.Drawing.Point(136, 424)
        Me.btnMerge.Name = "btnMerge"
        Me.btnMerge.Size = New System.Drawing.Size(104, 32)
        Me.btnMerge.TabIndex = 2
        Me.btnMerge.Text = "Merge XML"
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(8, 424)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(120, 32)
        Me.Button1.TabIndex = 1
        Me.Button1.Text = "Load From Database"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(776, 461)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnMerge, Me.Button1, Me.DataGrid1})
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        ' Purpose:  Populate the data grid with customers, from a DataSet

        Dim dsCustomers As DataSet        ' Form-level DataSet object

        ' Load list of customers into the combo box, from the DataSet
        dsCustomers = ListCustomersInDataSet()

        ' Bind the data grid to the DataSet
        DataGrid1.DataSource = dsCustomers

    End Sub

    Private Sub btnMerge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMerge.Click
        Dim dsOrg As DataSet = DataGrid1.DataSource
        Dim dsToMerge As DataSet = New DataSet()

        ' Read new data
        dsToMerge.ReadXml(Application.StartupPath & "\xmldata.xml", XmlReadMode.Auto)

        ' Perform the merge
        dsOrg.Merge(dsToMerge)

        DataGrid1.DataSource = dsOrg

    End Sub
    Friend WithEvents btnMerge As System.Windows.Forms.Button



    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
