Module Module1
    
    Sub Main()
        ' Create some columns
        Dim dcID As New DataColumn("ID", GetType(System.Int32))
        Dim dcQty As New DataColumn("Qty", GetType(System.Int32))
        Dim dcPrice As New DataColumn("Price", GetType(System.Int32))
        Dim dcExpression As New DataColumn("Expression", GetType(System.Boolean))

        ' Add the columns to the table
        Dim dtAuthors As New DataTable("Authors")
        dtAuthors.Columns.Add(dcID)
        dtAuthors.Columns.Add(dcQty)
        dtAuthors.Columns.Add(dcPrice)
        dtAuthors.Columns.Add(dcExpression)

        ' Create a DataSet and add the table to it
        Dim dsAuthors As New DataSet("dsAuthors")
        dsAuthors.Tables.Add(dtAuthors)

        ' Add three records to the table
        Dim drNewRow As DataRow

        drNewRow = dtAuthors.NewRow()
        drNewRow("ID") = 1
        drNewRow("Qty") = 10
        drNewRow("Price") = 120
        dtAuthors.Rows.Add(drNewRow)

        drNewRow = dtAuthors.NewRow()
        drNewRow("ID") = 2
        drNewRow("Qty") = 20
        drNewRow("Price") = 240
        dtAuthors.Rows.Add(drNewRow)

        drNewRow = dtAuthors.NewRow()
        drNewRow("ID") = 3
        drNewRow("Qty") = 30
        drNewRow("Price") = 360
        dtAuthors.Rows.Add(drNewRow)

        dtAuthors.AcceptChanges()

        ' Create a TotalPrice column
        dsAuthors.Tables(0).Columns("Expression").Expression = "Qty>=30"

        Dim r As DataRow

        For Each r In dsAuthors.Tables(0).Rows
            Console.WriteLine("ID" & r("ID") & ": " & r("Expression"))
        Next
    End Sub

End Module
