<%@ Page language="c#" Codebehind="PagingDataGrid1.aspx.cs" Inherits="DayOfDotNet.PagingDataGrid1" %>
<HTML>
	<META http-equiv="Content-Type" content="text/html; charset=windows-1252">
	<body style="FONT: x-small Verdana, Arial, sans-serif">
		<!-- Begin Web Form -->
		<form id="SortingDataGrid1" method="post" runat="server">
			<p>
				<a href="/ADayOfDotNet/">Parent Directory</a>
			</p>
			<!-- Begin DataGrid -->
			<asp:DataGrid id="DataGrid1" runat="server" AutogenerateColumns="False" CellPadding="2" CellSpacing="0" Font-Names="Verdana, Arial, sans-serif" BorderColor="Black" BorderWidth="1" GridLines="Horizontal" AllowSorting="True" OnSortCommand="SortCommand_OnClick" AllowPaging="True" PageSize="2" OnPageIndexChanged="DataGrid_PageIndexChanged">
				<PagerStyle Mode="NextPrev" PrevPageText="Previous" NextPageText="Next" Font-Bold="True" Font-Size="x-small" Font-Name="Arial" />
				<HeaderStyle Font-Bold="True" Font-Size="small" Font-Name="Arial" BackColor="Maroon" ForeColor="White" />
				<ItemStyle Font-Size="x-small" />
				<AlternatingItemStyle BackColor="Tan" />
				<Columns>
					<asp:TemplateColumn ItemStyle-VerticalAlign="Top">
						<ItemTemplate>
							<img src='images/<%# DataBinder.Eval(Container.DataItem, "ImageSrc") %>' Alt='<%# DataBinder.Eval(Container.DataItem, "Title" ) %>'>
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:HyperLinkColumn DataTextField="Title" DataNavigateUrlField="ISBN" DataNavigateUrlFormatString="DynamicEmbeddedDataGrid.aspx?isbn={0}" HeaderText="Title" ItemStyle-VerticalAlign="Top" SortExpression="Title" />
					<asp:TemplateColumn ItemStyle-VerticalAlign="Top" HeaderText="Info (Sort by Price)" SortExpression="Price">
						<ItemTemplate>
							<b>Publisher:</b> <a href='<%# DataBinder.Eval(Container.DataItem, "PublisherURL") %>' target="_blank">
								<%# DataBinder.Eval(Container.DataItem, "PublisherName") %>
							</a>
							<br>
							<b>Release Date:</b>
							<%# DataBinder.Eval(Container.DataItem, "ReleaseDate", "{0:d}") %>
							<br>
							<b>Price:</b>
							<%# DataBinder.Eval(Container.DataItem, "Price", "{0:c}") %>
							<br>
							<a href='<%# DataBinder.Eval(Container.DataItem, "AmazonLink") %>'>Buy Now! </a>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:DataGrid>
			<!-- End DataGrid -->
		</form>
		<!-- End Web Form -->
	</body>
</HTML>
