using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace PowerOfDotNet.Clubs
{
	/// <summary>
	/// GoAwayMember   Դϴ.
	/// </summary>
	public class GoAwayMember : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnGoAway;
		protected System.Web.UI.WebControls.TextBox txtSelfintroduction;
		protected System.Web.UI.WebControls.Label lblName;

		private int _clubId;
		private string _userId;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);
			_userId = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["userId"], "");

			if (!IsPostBack)
			{
				PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
				SqlDataReader dr = db.GetClubUserInfo(_clubId, _userId);
			
				if (dr.Read())
				{
					lblName.Text = dr["Name"].ToString();
					txtSelfintroduction.Text = dr["SelfIntroduction"].ToString();
				}
				else
				{
					MyWebLibs.Utilities.CommonMethods.PrintMsgAndClose("Ŭȸ ƴմϴ.");
				}
			}
			
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnGoAway.Click += new System.EventHandler(this.btnGoAway_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnGoAway_Click(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			int result = db.WithdrawalFromClub(_clubId, _userId);
			if (result == -2)
				MyWebLibs.Utilities.CommonMethods.PrintMsgAndClose("û Ż ȵ˴ϴ.");
			else if(result == 1)
				MyWebLibs.Utilities.CommonMethods.PrintMsgAndClose(" Żó Ǿϴ.");
			else
				MyWebLibs.Utilities.CommonMethods.PrintMsgAndClose(" ó!");

		}
	}
}
