using System;
using System.Collections;
using System.Web.UI.WebControls;

namespace Chapter04.Ex04
{
	public class Chap04_Ex04 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label lblStack;
		protected System.Web.UI.WebControls.Label lblQueue;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			lblStack.Text += "Stack Push : <br>";
			Stack stack = new Stack();

			for (int i=1;i<=5;i++)
			{
				stack.Push(i.ToString());
				lblStack.Text += "&nbsp;&nbsp;" + i + "<br>";
			}
			lblStack.Text += "<br>Stack  Ÿ Ʈ(Pop ȣ ) : <br>";
			DisplayList(stack, lblStack);

			lblStack.Text += "<br>Stack Pop : <br>";
			for (int i=1;i<=5;i++)
				lblStack.Text += "&nbsp;&nbsp;" + stack.Pop() + "<br>";

			lblStack.Text += "<br>Stack  Ÿ Ʈ(Pop ȣ ) : <br>";
			DisplayList(stack, lblStack);

			lblQueue.Text += "<br>Queue Enqueue : <br>";
			Queue queue = new Queue();
			for (int i=1;i<=5;i++)
			{
				queue.Enqueue(i.ToString());
				lblQueue.Text += "&nbsp;&nbsp;" + i + "<br>";
			}
			lblQueue.Text += "<br>Queue  Ÿ Ʈ(Dequeue ȣ ) : <br>";
			DisplayList(queue, lblQueue);

			lblQueue.Text += "<br>Queue Dequeue : <br>";
			for (int i=1;i<=5;i++)
				lblQueue.Text += "&nbsp;&nbsp;" + queue.Dequeue() + "<br>";

			lblQueue.Text += "<br>Queue  Ÿ Ʈ(Dequeue ȣ ) : <br>";
			DisplayList(queue, lblQueue);
		}

		public static void DisplayList( IEnumerable coll, Label label )  
		{
			IEnumerator enumerator = coll.GetEnumerator();
			while ( enumerator.MoveNext() )
				label.Text += "&nbsp;&nbsp;" + enumerator.Current + "<br>";
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
