using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Chapter07.Ex5
{
	public class Chap07_Ex05 : System.Web.UI.Page
	{
		protected Chap07_Ex05_uc02 Chap07_Ex05_uc021;

		protected System.Web.UI.WebControls.Label Label1;
	
		public HtmlForm GetForm()
		{
			foreach(Control c in this.Controls)
				if (c is HtmlForm)
					return (HtmlForm)c;

			return null;
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			HtmlForm form = GetForm();
			FindAllControlByID(form, "Label1");
		}

		private void FindAllControlByID(Control c, string ctrlId)
		{
			Control foundC = c.FindControl(ctrlId);
			if (foundC != null)
				Label1.Text += "<br>" + foundC.UniqueID;

			foreach (Control ec in c.Controls)
			{
				INamingContainer inc = ec as INamingContainer;
				if (inc != null)
					FindAllControlByID(ec, ctrlId);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
