using System;
using System.EnterpriseServices;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace ServicedComponents
{
	[ObjectPooling(MinPoolSize=1,MaxPoolSize=5, CreationTimeout=30)]
	[JustInTimeActivation(true)]
	public class ObjectPoolingDemo : ServicedComponent
	{
		public ObjectPoolingDemo()	
		{
			Trace.WriteLine("Ŭ  : ObjectPoolingDemo()");
		}

		protected override void Activate()
		{
			Trace.WriteLine("Activate()");
		}

		protected override void Deactivate()
		{
			Trace.WriteLine("Deactivate()");
		}

		protected override bool CanBePooled()
		{
			Trace.WriteLine("CanBePooled()");
			return true;
		}

		[AutoComplete]
		public void ObjectPoolingTest()
		{
			Trace.WriteLine("ObjectPoolingTest()");
		}
	}
}