using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.OleDb;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter16
{
	public class TestPage : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnEx01;
		protected System.Web.UI.WebControls.Button btnEx02;
		protected System.Web.UI.WebControls.Button btnEx03;
		protected System.Web.UI.WebControls.Button btnEx04;
		protected System.Web.UI.WebControls.Button btnEx05;
		protected System.Web.UI.WebControls.Button btnEx06;
		protected System.Web.UI.WebControls.Button btnEx07;
		protected System.Web.UI.WebControls.Button btnEx08;
		protected System.Web.UI.WebControls.Button btnEx09;
		protected System.Web.UI.WebControls.Button btnEx10;
		protected System.Web.UI.WebControls.Button btnEx11;
		protected System.Web.UI.WebControls.Button btnEx12;
		protected System.Web.UI.WebControls.Button btnEx13;
		protected System.Web.UI.WebControls.Button btnEx14;
		protected System.Web.UI.WebControls.Button btnEx15;
		protected System.Web.UI.WebControls.Button btnEx16;
		protected System.Web.UI.WebControls.Button btnEx17;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;

		private Chapter16_Ex_Collections db = null;
		private string sqlConnStr = String.Empty;
		private string oleDbConnStr = String.Empty;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (IsPostBack)
			{
				db = new Chapter16_Ex_Collections();
				sqlConnStr = ConfigurationSettings.AppSettings["SqlConnectionString"];
				oleDbConnStr = ConfigurationSettings.AppSettings["OleDbConnectionString"];
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.btnEx01.Click += new System.EventHandler(this.btnEx01_Click);
			this.btnEx02.Click += new System.EventHandler(this.btnEx02_Click);
			this.btnEx03.Click += new System.EventHandler(this.btnEx03_Click);
			this.btnEx04.Click += new System.EventHandler(this.btnEx04_Click);
			this.btnEx05.Click += new System.EventHandler(this.btnEx05_Click);
			this.btnEx06.Click += new System.EventHandler(this.btnEx06_Click);
			this.btnEx07.Click += new System.EventHandler(this.btnEx07_Click);
			this.btnEx08.Click += new System.EventHandler(this.btnEx08_Click);
			this.btnEx09.Click += new System.EventHandler(this.btnEx09_Click);
			this.btnEx10.Click += new System.EventHandler(this.btnEx10_Click);
			this.btnEx11.Click += new System.EventHandler(this.btnEx11_Click);
			this.btnEx12.Click += new System.EventHandler(this.btnEx12_Click);
			this.btnEx13.Click += new System.EventHandler(this.btnEx13_Click);
			this.btnEx14.Click += new System.EventHandler(this.btnEx14_Click);
			this.btnEx15.Click += new System.EventHandler(this.btnEx15_Click);
			this.btnEx16.Click += new System.EventHandler(this.btnEx16_Click);
			this.btnEx17.Click += new System.EventHandler(this.btnEx17_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnEx01_Click(object sender, System.EventArgs e)
		{
			db.Ex01();
		}

		private void btnEx02_Click(object sender, System.EventArgs e)
		{
			db.Ex02();
		}

		private void btnEx03_Click(object sender, System.EventArgs e)
		{
			db.Ex03(sqlConnStr);
		}

		private void btnEx04_Click(object sender, System.EventArgs e)
		{
			db.Ex04(sqlConnStr);
		}

		private void btnEx05_Click(object sender, System.EventArgs e)
		{
			db.Ex05(sqlConnStr);
		}

		private void btnEx06_Click(object sender, System.EventArgs e)
		{
			db.Ex06(sqlConnStr);
		}
		
		private void btnEx07_Click(object sender, System.EventArgs e)
		{
			db.Ex07(sqlConnStr);
		}

		private void btnEx08_Click(object sender, System.EventArgs e)
		{
			DataGrid1.DataSource = db.Ex08(oleDbConnStr);
			DataGrid1.DataBind();
		}

		private void btnEx09_Click(object sender, System.EventArgs e)
		{
			db.Ex09(sqlConnStr);
		}

		private void btnEx10_Click(object sender, System.EventArgs e)
		{
			db.Ex10(sqlConnStr);
		}
		
		private void btnEx11_Click(object sender, System.EventArgs e)
		{
			db.Ex11(oleDbConnStr);
		}

		private void btnEx12_Click(object sender, System.EventArgs e)
		{
			db.Ex12(sqlConnStr);
		}

		private void btnEx13_Click(object sender, System.EventArgs e)
		{
			db.Ex13(sqlConnStr);
		}

		private void btnEx14_Click(object sender, System.EventArgs e)
		{
			DataGrid1.DataSource = db.Ex14(sqlConnStr);
			DataGrid1.DataBind();
		}

		private void btnEx15_Click(object sender, System.EventArgs e)
		{
			db.Ex15(sqlConnStr);
		}

		private void btnEx16_Click(object sender, System.EventArgs e)
		{
			db.Ex16(sqlConnStr);
		}

		private void btnEx17_Click(object sender, System.EventArgs e)
		{
			SqlConnection sqlConn = new SqlConnection(sqlConnStr);
			db.Ex17(sqlConn, "Sql Server");

			OleDbConnection oleDbConn = new OleDbConnection(oleDbConnStr);
			db.Ex17(oleDbConn, "OLE DB");
		}
	}
}
