using System;
using System.Data;
using System.Drawing;
using System.Data.SqlClient;
using System.Data.Common;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter20.Ex11
{
	public class Chap19_Ex11 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid datgrdParent;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				datgrdParent.DataSource = GetParentData();
				datgrdParent.DataBind();
			}
		}

		//datgrdParent  ҽ .
		private SqlDataReader GetParentData()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation2";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		//datgrdChild  ҽ .
		//޼ҵ ڴ where 
		//tbDataPresentation2_Orders ̺ prodId 
		//ʵ ϱ  ȴ.
		private SqlDataReader GetChildData(int prodId)
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation2_Orders " + 
				"where prodId=" + prodId;
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.datgrdParent.ItemCreated += new System.Web.UI.WebControls.DataGridItemEventHandler(this.datgrdParent_ItemCreated);
			this.datgrdParent.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.datgrdParent_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void datgrdParent_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				//sender datgrdParent̴.
				DataGrid dgParent = ((DataGrid)sender);

				//εϱ  ID ڽ 
				//DataGrid Ʈ ι°  ´.
				DataGrid dgChild = (DataGrid)e.Item.Cells[1].FindControl("datgrdChild");
				// ׸ AlternatingItem ̸
				//ش  YellowGreen Ѵ.
				if (e.Item.ItemType == ListItemType.AlternatingItem)
					dgChild.HeaderStyle.BackColor = Color.YellowGreen;

				// ׸ Ű  ´.
				int id = (int)dgParent.DataKeys[e.Item.ItemIndex];
				// ׸ ӵ ͸ ؼ 
				//ͼҽ Ѵ. 
				dgChild.DataSource = GetChildData(id);
				dgChild.DataBind();
				//dgChild_SelectedIndexChanged  
				//ӵ θ ׸ Ű ˱ Ѵ.
				//dgChild.Attributes["parentId"] = id.ToString();
			}
		}

		private void dgChild_ItemDataBound(object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				DbDataRecord dataRecord = (DbDataRecord)e.Item.DataItem;
				//purchaseDate ʵ  "yyyyMMdd"  ´.
				string date = ((DateTime)dataRecord["purchaseDate"]).ToString("yyyyMMdd");
				//׹°  ¥ Ѵ.
				e.Item.Cells[3].Text = date;
			}
		}

		private void dgChild_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DataGrid dg = ((DataGrid)sender);

			/*θ DataGrid ID ϴ ΰ  ִ.*/
			//dg.Parent  DataGrid Ʈ Ե 
			//TableCell ṵ̈ ٽ  TableCell ü 
			//Parent DataGridItem ü̴.
			DataGridItem dgItem  = (DataGridItem)((TableCell)dg.Parent).Parent;
			//θ ׸ ID ´.
			int parentId = (int)datgrdParent.DataKeys[dgItem.ItemIndex];
			//Ǵ
			//datgrdParent_ItemDataBound ޼ҵ忡 
			//θ ׸ ID ̿Ѵ.
			//string parentId = dg.Attributes["parentId"];

			Response.Write(" : datgrdParent ID=" + parentId + 
				", datgrdChild ε=" + dg.SelectedIndex + 
				", datgrdChild ID=" + dg.DataKeys[dg.SelectedIndex] +
				"<br>");
		}

		private void datgrdParent_ItemCreated(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				//̺Ʈ ڵ鷯 ϱ ڽ 
				//DataGrid Ʈ ι°  ´.
				DataGrid dgChild = (DataGrid)e.Item.Cells[1].FindControl("datgrdChild");
				//̺Ʈ ڵ鷯 Ѵ.
				dgChild.ItemDataBound += new DataGridItemEventHandler(this.dgChild_ItemDataBound);
				dgChild.SelectedIndexChanged += new EventHandler(dgChild_SelectedIndexChanged);
			}
		}
	}
}
