using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CustomControls.Ex08
{
	public class Ex08_Control : WebControl
	{
		public Ex08_Control() : base(HtmlTextWriterTag.A) {}

		protected override void RenderContents(HtmlTextWriter writer)
		{
			writer.Write("Power of .NET");
			base.RenderContents(writer);
		}

		protected override void AddAttributesToRender(HtmlTextWriter writer)
		{
			writer.AddAttribute(HtmlTextWriterAttribute.Href, "http://www.powerof.net");
			base.AddAttributesToRender(writer);
		}
	}
}
