<script language="C#" runat="server">
const int maxRows = 3;
const int maxCols = 5;

protected override void Render(HtmlTextWriter writer) {
	writer.WriteFullBeginTag("h3");
	writer.Write("HtmlTextWriter  1");
	writer.WriteEndTag("h3");
	writer.WriteLine();

	writer.WriteFullBeginTag("table");
	writer.Indent++;
	writer.WriteLine();

	writer.WriteBeginTag("tr");
	writer.Write(HtmlTextWriter.SpaceChar);
	writer.Write("style");
	writer.Write(HtmlTextWriter.EqualsDoubleQuoteString); // ="
	writer.WriteStyleAttribute("background-color", "lightgreen");
	writer.WriteStyleAttribute("font-weight", "bold");
	writer.Write(HtmlTextWriter.DoubleQuoteChar);
	writer.Write(HtmlTextWriter.TagRightChar);
	writer.WriteLine();
	writer.Indent++;
	for (int i=1; i<maxCols; i++) 
	{
		writer.WriteBeginTag("td");
		writer.WriteAttribute("valign","top");
		writer.Write(HtmlTextWriter.TagRightChar);
		writer.Write("÷ (" + i + ")" );
		writer.WriteEndTag("td");
		writer.WriteLine();
	}
	writer.Indent--;
	writer.WriteEndTag("tr");
	writer.WriteLine();

	for (int i=1; i<maxRows; i++) 
	{
		writer.WriteBeginTag("tr");
		writer.WriteAttribute("bgcolor","yellow");
		writer.Write(HtmlTextWriter.TagRightChar);
		writer.WriteLine();

		writer.Indent++;
		for (int j=1; j<maxCols; j++) 
		{
			writer.WriteBeginTag("td");
			writer.WriteAttribute("valign","top");
			writer.Write(HtmlTextWriter.TagRightChar);
			writer.Write("Cell (" + i.ToString() + "," + j.ToString() + ")" );
			writer.WriteEndTag("td");
			writer.WriteLine();
		}
		writer.Indent--;
		writer.WriteEndTag("tr");
		writer.WriteLine();
	}
	writer.Indent--;

	writer.WriteEndTag("table");
	writer.WriteLine();
}
</script>
