if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Add_ADO_TUT_2]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[Add_ADO_TUT_2]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AdoTutSimpleSelect]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[AdoTutSimpleSelect]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[GetPagePortionInOrders]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[GetPagePortionInOrders]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Get_ADO_TUT_2_ByOUTPUT]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[Get_ADO_TUT_2_ByOUTPUT]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE Add_ADO_TUT_2
(
@integerType int,
@stringType varchar(50)
)
AS

INSERT INTO tbADO_TUT_2  (
	integerType,
	stringType  
	)
VALUES   (
	@integerType,
	@stringType 
	)

return @@IDENTITY
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE AdoTutSimpleSelect
 AS

select stringType from tbADO_TUT_1
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE GetPagePortionInOrders
@PAGE INT, -- ȣ
@ROW_COUNT INT --ޱ ϴ 
AS 
DECLARE @TOTAL_PAGE INT
DECLARE @SQL VARCHAR(200) 
DECLARE @TOTAL_RECORDS INT, @REMAINDER INT, @ASC_COUNT INT
SELECT @TOTAL_RECORDS = COUNT(*) FROM tbDataPresentation2_Orders 

--ü ڵ带   .
SET @TOTAL_PAGE = CEILING (@TOTAL_RECORDS / @ROW_COUNT)
-- 
SET @REMAINDER = @TOTAL_RECORDS % @ROW_COUNT
if @REMAINDER > 0
begin
    set @ASC_COUNT = (@TOTAL_RECORDS - (@PAGE - 1) * @ROW_COUNT)
    set @TOTAL_PAGE = @TOTAL_PAGE + 1
    if @PAGE = @TOTAL_PAGE
    begin
        set @ROW_COUNT = @REMAINDER
    end
end
else
begin
    set @ASC_COUNT = (@TOTAL_RECORDS - (@PAGE - 1) * @ROW_COUNT)
end

if @TOTAL_PAGE < @PAGE
begin
    PRINT '  ߸Ǿϴ.'
    return
end

--Ĺ ̿ ϴ κи Ѵ.
SET @SQL = 'SELECT TOP ' + CONVERT(VARCHAR(10), @ROW_COUNT)
SET @SQL = @SQL + ' id, purchaseName, priceTotal, purchaseDate FROM (SELECT TOP '
SET @SQL = @SQL + CONVERT(VARCHAR(10), @ASC_COUNT) 
SET @SQL = @SQL + ' id, purchaseName, priceTotal, purchaseDate FROM tbDataPresentation2_Orders ORDER 
BY id ASC) A '
SET @SQL = @SQL + 'ORDER BY id DESC' 
EXEC (@SQL)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE Get_ADO_TUT_2_ByOUTPUT
(
@integerType int,
@stringType varchar(50) OUTPUT
)
AS

select @stringType=stringType from tbADO_TUT_2 
where integerType=@integerType
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

