using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;

namespace Chapter20
{
	public class ShopOverImageManager : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataList datlstOverImages;
		protected System.Web.UI.WebControls.Button btnImageUpload;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileOverImage;

		protected string dirName = String.Empty;

        private void Page_Load(object sender, System.EventArgs e)
		{
			string kind = Request.QueryString["kind"];
			if (kind == null)
				throw new Exception("GET Ķͷ kind ޵ ʾҽϴ.");
		
			//GET Ķ͸ о
			//̹ ϰų о ͸ 
			switch (kind) {
				case "S" :
					dirName = "Sale";
					break;
				case "B" :
					dirName = "Best";
					break;
				case "R" :
					dirName = "Recom";
					break;
			}

			if (!IsPostBack) {
				OverImagesDataBind();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnImageUpload.Click += new System.EventHandler(this.btnImageUpload_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		//ε ̹ ͸ Ѵ.
		private void btnImageUpload_Click(object sender, System.EventArgs e)
		{
			string fileName = fileOverImage.PostedFile.FileName;
			//ε  ִ ˻Ѵ.
			if (fileName.Trim() != String.Empty) {
				//ä ο ϸ ߶
				fileName = fileName.Substring(fileName.LastIndexOf("\\") + 1);
				fileName = fileName.ToLower();
				//Ȯڰ jpg gif ˻
				if (fileName.Substring(fileName.Length-4) == ".jpg" || 
					fileName.Substring(fileName.Length-4) == ".gif") {
					//ε ̹ 
					fileOverImage.PostedFile.SaveAs(MapPath("/shop/Images/" + dirName + "/") + fileName);
					//ε ̹ ֵ  ε
					OverImagesDataBind();
				}
				else {
					MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Jpeg Gif  ϸ ε մϴ.");
				}
			}
		}

		private void OverImagesDataBind()
		{
			ArrayList overImages = new ArrayList();
			//͸ ִ gif  о
			string[] aImages = Directory.GetFiles(MapPath("/shop/Images/" + dirName + "/"), "*.gif");

			// ̸  overImages ߰
			foreach (string image in aImages) {
				overImages.Add(image.Substring(image.LastIndexOf("\\") + 1));
			}

			//͸ ִ jpg  о
			aImages = Directory.GetFiles(MapPath("/shop/Images/" + dirName + "/"), "*.jpg");
			// ̸  overImages ߰
			foreach (string image in aImages) {
				overImages.Add(image.Substring(image.LastIndexOf("\\") + 1));
			}

			datlstOverImages.DataSource = overImages;
			datlstOverImages.DataBind();
		}
	}
}
