/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.Clubs.Board
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		ClubContent   Դϴ.
	/// </summary>
	public abstract class ClubContent : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.Button btnEdit;
		protected System.Web.UI.WebControls.Button btnReply;

		protected int _mid;
		protected System.Web.UI.WebControls.Label lblContent;
		protected System.Web.UI.WebControls.Label lblViewed;
		protected System.Web.UI.WebControls.Label lblRegDate;
		protected System.Web.UI.WebControls.Label lblWriter;
		protected System.Web.UI.WebControls.Label lblSubject;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnToList;
		protected System.Web.UI.WebControls.PlaceHolder plachdrFiles;
		protected System.Web.UI.WebControls.LinkButton lnkbtnDelete;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnImitationDelete;
		protected PowerOfDotNet.Avatar.AvatarPlugIn Avatarplugin1;
		protected int _pid;

		private string ClubDeleteConfirmScript = @"
<SCRIPT LANGUAGE=""JavaScript"">
<!--
function _PowerOf_ClubDeleteConfirm(id)
{{
		if (window.confirm(""Խù  Ͻðڽϱ?""))
			__doPostBack(id,'');
}}
//-->
</SCRIPT>
";

		public int PID
		{
			get
			{
				return _pid;
			}
			set
			{
				_pid = value;
			}
		}

		private PowerOfDotNet.Components.BoardClubInfo _blInfo;

		private void Page_Load(object sender, System.EventArgs e)
		{

			PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();

			int boardId = Convert.ToInt32(Request.Params["TableId"]);

			//ɽÿ   ´.
			_blInfo = (Components.BoardClubInfo)this.GetObjectFromCache("BoardClubTableInfo" + boardId);
			if (_blInfo == null)
			{
				_blInfo = db.GetBoardInfo(boardId);
				this.SetObjectToCache("BoardClubTableInfo" + boardId, _blInfo, 30);
			}

			SqlDataReader dr = db.GetContent(_blInfo.BBSTable, _pid);
			dr.Read();
			if (dr.GetByte(6) == 0)
			{
				lblContent.Text = Server.HtmlEncode(dr.GetString(3)).Replace("\n","<br>");
			}
			else
			{
				string strContentUri = "/Clubs/Board/GetClubHTMLContent.aspx?PID=" + _pid.ToString() + "&Table=" + _blInfo.BBSTable + "&bypass=true";
				// iframe ̿ 
				LiteralControl oIFrame = new LiteralControl("<iframe src=\""+ strContentUri + "\" frameborder=0 scrolling=outo width=100% height=500 topmargin=0 leftmargin=10 marginheight=0 marginwidth=0 name=\"Content\" allowtransparency=\"true\"></iframe>");
				lblContent.Controls.Clear();
				lblContent.Controls.Add(oIFrame);
			}
			lblWriter.Text = dr.GetString(0);
			lblSubject.Text = dr.GetString(1);
			lblRegDate.Text = dr.GetDateTime(2).ToString();
			lblViewed.Text = dr.GetInt32(4).ToString();

			if (dr.GetBoolean(10))
			{
				//ƹŸ 
				Avatarplugin1.UserID = dr.GetString(9);
				Avatarplugin1.Expression = dr.GetByte(11).ToString();
			}	
			else
				Avatarplugin1.Visible = false;
		
			//ȸ 
			object increaseCheck = this.Session["LactureForVistedIncrease"];
			if (increaseCheck == null) increaseCheck = (object)String.Empty;
			if ((string)increaseCheck != Request.RawUrl)
			{
				db.IncVisted(_blInfo.BBSTable, _pid);
			}

			int clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);
			Components.ClubInfo clubInfo = ClubsUtil.GetClubInfo(this, clubId);

			string userId = Page.User.Identity.Name;
			bool authority = false;
			bool gongJiAuthority = true;

			if (_blInfo.BBSType == 0)
				authority = gongJiAuthority = Clubs.ClubsUtil.CheckUserAuthorityForGongJi(userId, clubInfo, _blInfo);
			else {
				//۾
				if (dr.GetString(9).Trim() == userId)	authority = true;
					// Ŭ 
				else if (Clubs.ClubsUtil.CheckUserAuthority(userId, clubInfo))	authority = true;
				else	authority = false;
			}
			dr.Close();

			if (authority && gongJiAuthority) {
				_mid = ((ClubContentGroup)this.Parent.Parent.Parent).GroupInfo.MID;

				lnkbtnDelete.CommandArgument = _mid.ToString() + ":" + _pid.ToString() + ":" + _blInfo.BBSTable;
				//lnkbtnDelete.UniqueID ڷ Ѱش
				btnImitationDelete.Attributes["onclick"] = "_PowerOf_ClubDeleteConfirm('" + lnkbtnDelete.UniqueID + "')";
				btnEdit.CommandArgument = _pid.ToString() + ":" + _blInfo.BBSID;
			}
			else {
				btnImitationDelete.Disabled = true;
				btnEdit.Enabled = false;
			}

			if (gongJiAuthority)
				btnReply.CommandArgument = _pid.ToString() + ":" + _blInfo.BBSID;
			else
				btnReply.Visible = false;
		

			//÷ ũ 
			SqlDataReader drf = db.GetFileInfo(_blInfo.BBSTable, _pid);
			while (drf.Read())
			{
				HyperLink hl = new HyperLink();
				//mode=download  
				hl.NavigateUrl = "GetClubImage.ashx?bypass=true&mode=download&PID=" + PID.ToString() + "&Table=" + _blInfo.BBSTable + "&FileName=" + drf.GetString(0);
				hl.Text = drf.GetString(0) + "(" + drf.GetInt32(1) + ")";
				plachdrFiles.Controls.Add(hl);
				plachdrFiles.Controls.Add(new LiteralControl("&nbsp;&nbsp;"));
			}
			drf.Close();

			string param = Clubs.ClubsUtil.GetGenParam();
			btnToList.Attributes["onclick"] = "window.location.href='" + 
				GetLink(_blInfo.BBSPageNameList) + "&" + param + 
				"&TableId=" + _blInfo.BBSID + "&clubId=" + clubId + "'";

			//ũƮ  lnkbtnDelete ̺Ʈ ȣϴ Լ 
			//ClubDeleteConfirmScript = String.Format(ClubDeleteConfirmScript, this.Page.GetPostBackEventReference(lnkbtnDelete, ""));
			this.Page.RegisterClientScriptBlock("ClubDeleteConfirmScript", ClubDeleteConfirmScript);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
