using System;
using System.IO;
using System.Web;
using System.Web.Caching;
using System.Data;

using MarkPasternak.Utility;

namespace PowerOfDotNet
{
	public class GetDownloadFile : IHttpHandler
	{
		public void ProcessRequest(HttpContext context)
		{
			string strFileName = context.Request.QueryString["file"].ToString();
			strFileName = context.Request.MapPath(context.Request.ApplicationPath + "/" + strFileName);

			WriteFileHelper fileTran = new WriteFileHelper();

			//  3  ʿ ó ƴմϴ.
			fileTran.BufferSize = 1024;
			fileTran.DownloadCancelled += new EventHandler(this.DownloadCancelled_Handler);
			fileTran.DownloadCompleted += new EventHandler(this.DownloadCompleted_Handler);

			//  Ѵ.
			fileTran.WriteFileToResponseStreamWithForceDownloadHeaders(strFileName);


		}

		public bool IsReusable
		{
			get { return true; }
		}

		private void DownloadCancelled_Handler(object sender, System.EventArgs e)
		{
			//  ó
		}

		private void DownloadCompleted_Handler(object sender, System.EventArgs e)
		{
			//  ó
		}

	}
}
